# File hectospec/efast.cl
# May 10, 1999
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# EFAST -- Remove sky from a spectrum by fitting eigenvectors for
#          a list of FAST observation numbers

procedure efast (rfnfile)

string	rfnfile=""	{prompt="RFN or file"}
int	band=1		{prompt="Band if multispec file"}
string	rootdir="/ret/ret7/fast/"	{prompt="Root directory"}
file	vecfile1="evec1.fits"	{prompt="First pass eigenvector file"}
string	vec1="1,2"	{prompt="First pass eigenvectors"}
file	vecfile2="evec2.fits"	{prompt="Second pass eigenvector file"}
string	vec1="1-9"	{prompt="Second pass eigenvectors"}
bool	plot=yes	{prompt="Plot results on display (y or n)"}
bool	hard_copy=no	{prompt="Make printer hard copies (y or n)"}
bool	cursor=no	{prompt="Wait after plot with cursor (y or n)"}
bool	delfile=yes	{prompt="Delete IRAF copy of archive file (y or n)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf, plres,hcres
bool	curwait, emxc
int	nobs, npix, i
file	iraffile, irafhead, irafpix, rfn_temp
file	localfile, localpix, localhead, newpix,newpath
string	line1, line2
file	listfile, obsdir, irafpath
string	tchar, obsdate, arg, arg1, rfile, emtemp, besttemp

	rfile = rfnfile
	vb = verbose
	delf = delfile
	plres = plot
	hcres = hard_copy
	curwait = cursor

	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.destdir = ""
	eigenres.specband = band

	set clobber = yes

#  Process data files from RFN or file of RFN's
	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("arcrfn")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr(rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
	obnobj.root_dir = rootdir
	obnobj.verbose = no

#  Loop through list of reduced files
	list = listfile
	i = 0
	while (fscan (list, line) != EOF) {
	    i = i + 1
	    rfast1 (line)
	    localfile = rfast1.destpath

	# If the reduced file is found, process a local copy of it
	    if (localfile != "") {
		esky (localfile)

		if (hcres)
		    gflush
		}
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end

# May 10 1999	New task
