# File svdfit/svdsky.cl
# October 10, 2000
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# SVDSKY -- Decompose a set of spectra into their eigenvectors

procedure svdsky (infile)

string	infile=""	{prompt="Two-dimensional file of stacked spectra"}

string	outfile=""	{prompt="Two-dimensional file of stacked eigenvectors"}
int	pass=0		{prompt="Number of the current pass"}

bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf
string	arg, ofile

	if (infile != "") {
	    if (outfile == "") {
		fileroot (infile)
		ofile = fileroot.rootname // ".svd"
		if (pass > 0) {
		    ofile = ofile // pass
		    }
		ofile = ofile // "." // fileroot.extname
		}
	    else
		ofile = outfile
	    arg = infile // " " // ofile
	    if (pass > 0) {
		arg = arg // " " // pass
		}
	    if (verbose) {
		print ("svdsky ", arg)
		}
	    esvdsky (arg)
	    }
	else {
	    print ("SVDSKY:  Input file must be specified")
	    }
end

# Sep  9 1999	New task
