/* File TDC/hectospec/makename.c
 * March 3, 1999
 * By Doug Mink, Harvard-Smithsonian Center for Astrophysics
 */

/* MAKENAME Make object name from right ascension and declination */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *strnsrch();
static char *strsrch();

main (ac, av)
int ac;
char **av;
{
    int lra, ldec, iob, i;
    char *ra, *dec;
    char objname[64];

/* Print commands if no arguments */
    if (--ac <= 0) {
	printf ("makename hh:mm:ss.ss sdd:mm:ss returns object name\n");
	return;
	}

    /* Decode argument */
    ra = *++av;
    dec = *++av;

    if (ra != NULL && dec != NULL) {
	iob = 0;
	lra = strlen (ra);
	if (ra[1] == ':')
	    objname[iob++] = '0';
	for (i = 0; i < lra; i++) {
	    if (ra[i] != ':' && ra[i] != '.')
		objname[iob++] = ra[i];
	    }
	if (dec[0] == '+') {
	    objname[iob++] = 'p';
	    if (dec[2] == ':')
		objname[iob++] = '0';
	    }
	else if (dec[0] == '-') {
	    objname[iob++] = 'm';
	    if (dec[2] == ':')
		objname[iob++] = '0';
	    }
	else {
	    objname[iob++] = 'p';
	    if (dec[1] == ':')
		objname[iob++] = '0';
	    }
	ldec = strlen (dec);
	for (i = 0; i < ldec; i++) {
	    if (dec[i]!=':' && dec[i]!='.' && dec[i]!='-' && dec[i]!='+')
		objname[iob++] = dec[i];
	    }
	objname[iob] = (char)0;
	printf ("%s\n", objname);
	}
    else
	printf ("either RA or Dec missing\n");
}
/* Mar  3 1999	New program
 */
