c*** File fitslib/fcon.f
c*** June 12, 1992
c*** By Doug Mink

c  FCON (DATE,TIME,TSEC)
c	Convert date as 'dd/mm/yy' and time as hh:mm:sss to seconds since 1950.0

c  FCON1 (TSEC,DATE,TIME)
c	Convert seconds since 1950.0 to date as 'dd/mm/yy' and time as 'hh:mm:sss'

c  FCONA (FDEG,STRING)
c	Convert angle in degrees to angle as 'dd:mm:sss'


c  FCON-- Convert date as 'dd/mm/yy' and time as hh:mm:sss to seconds since 1950.0

	Subroutine FCON (DATE,TIME,TSEC)

	Character*(*) DATE
c			Date as dd/mm/yy
c			    dd = calendar day (e.g. 15)
c			    mm = calendar month (e.g. 04 = april)
c			    yy = calendar year (e.g. 1973)
	Character*(*) TIME
c			Time as hh:mm:ss
c			    hh = hour of day (0 .le. hh .le. 23)
c			    nn = minutes (0 .le. nn .le. 59)
c			    ss = seconds (0 .le. ss .le. 59)
c			  xxxx = tenths of milliseconds (0 .le. xxxx .le. 9999)
	Real*8 TSEC
c			Seconds past 1950.0 (returned)

	Real*8 D,T
	Integer*4 IY,IM,ID,LDATE,IER,IS1,IS2,LTIME
	Character*5 TEMP

	Call VLEN (DATE,LDATE)

	IS1 = Index (DATE,'/')
	TEMP = DATE(1:IS1-1)
	Read(TEMP,*) ID
	IS2 = Index (DATE(IS1+1:),'/') + IS1
	TEMP = DATE(IS1+1:IS2-1)
	Read(TEMP,*) IM
	TEMP = DATE(IS2+1:LDATE)
	Read(TEMP,*) IY
	If ((IY .lt. 100) .and. (IY .gt. 50)) Then
	    IY = IY + 1900
	Elseif (IY .lt. 100) Then
	    IY = IY + 2000
	Endif
	D = Dble (IY) + (1.d-2 * Dble (IM)) + (1.d-4 * Dble (ID))

	Call VLEN (TIME,LTIME)
	Call ASCBINR8 (LTIME,TIME,T,IER)

	Call VCON (D,T,TSEC)

	Return
	End


c  FCON1-- Convert seconds since 1950.0 to date as 'dd/mm/yy' and time as 'hh:mm:sss

	Subroutine FCON1 (TSEC,DATE,TIME)

	Real*8 TSEC
c			Seconds past 1950.0
	Character*(*) DATE
c			Date as 'dd/mm/yy'
c			    mm = calendar month (e.g. 04 = april)
c			    yyyy = calendar year (e.g. 1973)
c			    dd = calendar day (e.g. 15)
	Character*(*) TIME
c			Time as 'hh:mm:ss'
c			    hh = hour of day (0 .le. hh .le. 23)
c			    nn = minutes (0 .le. nn .le. 59)
c			    ss = seconds (0 .le. ss .le. 59)
c			  xxxx = tenths of milliseconds (0 .le. xxxx .le. 9999)

	Integer*4 IY,IYR,IM,ID,IHR,IMN,ISEC
	Real*8 SEC

	If (Dmod (TSEC,1.d0) .gt. 0.5d0) TSEC = TSEC + 1.d0
	Call VCON2 (TSEC,IYR,IM,ID,IHR,IMN,SEC)
	ISEC = Idnint (SEC)
	IY = IYR - 1900
	If (IY .gt. 99) IY = IY - 100

c  Write date string

	Write(DATE,10) ID,IM,IY
10	Format(I2,'/',I2,'/',I2)
	Call PADNULL (DATE)
	If (DATE(1:1) .eq. ' ') DATE(1:1) = '0'
	If (DATE(4:4) .eq. ' ') DATE(4:4) = '0'
	If (DATE(7:7) .eq. ' ') DATE(7:7) = '0'

c  Write time string

	Write(TIME,20) IHR,IMN,ISEC
20	Format(I2,':',I2,':',I2)
	Call PADNULL (TIME)
	If (TIME(1:1) .eq. ' ') TIME(1:1) = '0'
	If (TIME(4:4) .eq. ' ') TIME(4:4) = '0'
	If (TIME(7:7) .eq. ' ') TIME(7:7) = '0'

	Return
	End


c  FCONA-- Convert angle in degrees to angle as 'dd:mm:sss'

	Subroutine FCONA (FDEG,STRING)

	Real*8 FDEG
c			Angle in degrees
	Character*(*) STRING
c			Angle as '[-]dd:mm:ss'
c			    dd = angle in degrees between -180 and +180
c			    mm = minutes (0 .le. nn .le. 59)
c			    ss = seconds (0 .le. ss .le. 59)
c			  xxxx = tenths of milliseconds (0 .le. xxxx .le. 9999)

	Logical NEGSIGN
	Integer*4 IHR,IMN,ISEC
	Real*8 FSEC

	FSEC = FDEG * 3.6d3
	If (FSEC .lt. 0) Then
	    NEGSIGN = .true.
	    FSEC = -FSEC
	Else
	    NEGSIGN = .false.
	Endif
	ISEC = Idnint (FSEC)
	IHR = ISEC / 3600
	ISEC = ISEC - (IHR * 3600)
	IMN = ISEC / 60
	ISEC = ISEC - (IMN * 60)

c  Write time string

	If (NEGSIGN) Then
	    Write(STRING,10) IHR,IMN,ISEC
10	    Format('-',I2,':',I2,':',I2)
	    Call PADNULL (STRING)
	    If (STRING(2:2) .eq. ' ') STRING(2:2) = '0'
	    If (STRING(5:5) .eq. ' ') STRING(5:5) = '0'
	    If (STRING(8:8) .eq. ' ') STRING(8:8) = '0'
	Else
	    Write(STRING,20) IHR,IMN,ISEC
20	    Format(I2,':',I2,':',I2)
	    Call PADNULL (STRING)
	    If (STRING(1:1) .eq. ' ') STRING(1:1) = '0'
	    If (STRING(4:4) .eq. ' ') STRING(4:4) = '0'
	    If (STRING(7:7) .eq. ' ') STRING(7:7) = '0'
	Endif

	Return
	End
