c*** File fitslib/fitsmark.f
c*** September 18, 2003
c*** By Doug Mink

c--- Mark FITS image region

	Subroutine FITSMARK (HEADER,IMAGE,IX1,IX2,IY1,IY2,DVAL)

	Character*(*) HEADER
c				Header string
	Integer*4 IMAGE(*)
c				FITS image (modified)
	Integer*4 IX1,IY1
c				One corner of region to be marked
	Integer*4 IX2,IY2
c				Other corner of region to be marked
	Real*8 DVAL
c				Value to insert in image

	Integer*4 BITPIX,NAXIS,NAXIS1,NAXIS2,IR1,IR2,IC1,IC2
	Integer*4 OFFSET,NC,NBR0,NBPIX,IR,IVAL
	Integer*2 JVAL
	Real*4 RVAL
	Character*80 STRING
	Include 'header.cmb'

	Call ESET

c  Get dimensions of image

	Call HGETI4 (HEADER,'BITPIX',BITPIX)
	Call HGETI4 (HEADER,'NAXIS',NAXIS)
	Call HGETI4 (HEADER,'NAXIS1',NAXIS1)
	If (NBPIX .gt. 0) Then
	    NBPIX = BITPIX / 8
	Else
	    NBPIX = -BITPIX / 8
	Endif
	NBR0 = NAXIS1 * NBPIX
	If (NAXIS .gt. 1) Then
	    Call HGETI4 (HEADER,'NAXIS2',NAXIS2)
	    NBR0 = NBR0 * NAXIS2
	    Endif
	IVAL = Idnint (DVAL)
	If (BITPIX .eq. 8) Then
	    If (IVAL .lt. 256) Then
		JVAL = IVAL
	    Else
		JVAL = 255
	    Endif
	Elseif (BITPIX .eq. 16) Then
	    If (IVAL .gt. 32767) Then
		JVAL = 32767
	    Elseif (IVAL .lt. -32768) Then
		JVAL = -32768
	    Else
		JVAL = IVAL
	    Endif
	Elseif (BITPIX .eq. -32) Then
	    RVAL = DVAL
	Endif

c  Set column limits and number of columns to mark

	If (IX2 .ge. IX1) Then
	    IC1 = IX1
	    IC2 = IX2
	Else
	    IC2 = IX1
	    IC1 = IX2
	Endif
	If (IC1 .lt. 1) IC1 = 1
	If (IC2 .gt. NAXIS1) IC2 = NAXIS1
	NC = IC2 - IC1 + 1

c  Set row limits to mark

	If (IY2 .ge. IY1) Then
	    IR1 = IY1
	    IR2 = IY2
	Else
	    IR2 = IY1
	    IR1 = IY2
	Endif
	If (IR1 .lt. 1) IR1 = 1
	If (IR2 .gt. NAXIS2) IR2 = NAXIS2

	If (VERBOSE) Then
	    Write(STRING,*) 'Marking rows',IR1,' -',IR2,' columns',IC1,' -',IC2
	    Call PSTRING (STRING)
	    Write(STRING,*) 'Image is',NAXIS1,' x',NAXIS2
	    Call PSTRING (STRING)
	    Endif

c  Offset is zero-based

	OFFSET = (IR1 - 2) * NAXIS1 + (IC1 - 1)

c  Set bits

	Do 100 IR = IR1, IR2
	    OFFSET = OFFSET + NAXIS1
	    If (BITPIX .eq. 8) Then
		Call SVSET1C (JVAL,IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. 16) Then
		Call SVSET2C (JVAL,IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. 32) Then
		Call SVSET4C (IVAL,IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. -32) Then
		Call SVSETRC (RVAL,IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. -64) Then
		Call SVSETDC (DVAL,IMAGE,OFFSET,NC)
	    Endif
100	    Continue

	Return
	End
c Mar 28 1991	New subroutine

c Jan 17 1997	Allow any FITS data type

c Sep 18 2003	Use svsetdc() instead of svsetrc() for real*8
