c*** File fitslib/fitsphead.f
c*** February 25, 1993
c*** By Doug Mink

c--- Print FITS header
c    Note settings of /HEADER/ common.

	Subroutine FITSPHEAD (FNAME,HSTRING)

	Character*(*) FNAME
c				File name
	Character*(*) HSTRING
c				Header string (returned)

	Integer*4 NR
c				Number of characters read (returned)
c				Value of 0 returned if unsuccessful
	Integer*4 IFIL
c				UNIX file from which to read

	Character NULL*1, TEMP*80
	Integer*4 LHEAD,LMAX,IEND,ILINE,NLINES,LFNAM,LREC,LHEAD0
	Integer*4 I,I0,IER,I1

	Include 'header.cmb'

	NULL = Char (0)
	Call ESET

c  Initialize header string to NULL

	LMAX = Len (HSTRING)
	Do 40 I = 1, LMAX
40	   HSTRING(I:I) = NULL

c  Open data file, returning if not found

	If ((FNAME(1:1) .ne. '-') .and. (FNAME(1:1) .ne. NULL)) Then
	    Call VLEN (FNAME,LFNAM)
	    IFIL = -2
	    NR = 0
	    Call OPENR (IFIL,FNAME)
	    If (IFIL .lt. 3) Return

c  Read first block of FITS header

	    LHEAD = 2880
	    LREC = 2880
	    Call SGETC (IFIL,LREC,HSTRING,NR)
50	    If (NR .lt. 2) Then
		Call ESET
		Write(*,60) NR,FNAME(1:LFNAM)
60		Format('FITSPHEAD:',I3,' bytes in file "',A,'"')
		NR = 0
		Return
		Endif

c  If END is found, pad rest of header string with NULLs

	    I0 = 1
	    Call HSEARCH (HSTRING,'END',IEND)
	    If (IEND .gt. 0) Then
		I0 = IEND + 80
		Do 100 I = I0, LMAX
100		    HSTRING(I:I) = NULL

c  If END is not found, read next block

	    Else
		LHEAD0 = LHEAD + 1
		LHEAD = LHEAD + LREC
		If (LHEAD .gt. LMAX) Then
		    Write(*,105) FNAME
105		    Format('FITSPHEAD: No header END in file "',A,'"')
		    NR = 0
		    Go to 110
		    Endif
		Call SGETC (IFIL,LREC,HSTRING(LHEAD0:LHEAD),NR)
		Go to 50
	    Endif

110	    Call SCLOSE (IFIL,IER)
	    If (VERBOSE) Then
		Call ESET
		Write(*,120) LHEAD,FNAME
120		Format('FITSREAD:',I5,'-byte header read from file "',A,'"')
		Endif
	    NR = LHEAD
	Else
	    Call HSEARCH (HSTRING,'END',IEND)
	Endif

c  Print header

	NLINES = IEND / 80
	If (NLINES .gt. 0) Then
	    I1 = 1
	    Do 200 ILINE = 1, NLINES
		TEMP = HSTRING(I1:I1+79)
		Call PADNULL (TEMP)
		Call PSTRING (TEMP)
200		I1 = I1 + 80
	    Endif

	Return
	End

c Feb 25 1993	Drop unused variable ltemp; initialize i1
