c*** File fitslib/fitsprint.f
c*** March 28, 1991
c*** By Doug Mink

c--- Mark FITS image region

	Subroutine FITSPRINT (HEADER,IMAGE,IX1,IX2,IY1,IY2)

	Character*(*) HEADER
c				Header string
	Integer*4 IMAGE(*)
c				FITS image (modified)
	Integer*4 IX1,IY1
c				First row, column to print
	Integer*4 IX2,IY2
c				Last row, column to print

	Integer*4 BITPIX,NAXIS,NAXIS1,NAXIS2,IR1,IR2,IC1,IC2
	Integer*4 OFFSET,NBPIX,NBCOL,NC,NBR0,I,IR,IC
	Integer*4 ILINE(20)
	Integer*2 JLINE(20)
	Integer*2 KLINE(20)
	Character*120 STRING
	Include 'header.cmb'

	Call ESET

c  Get dimensions of image

	Call HGETI4 (HEADER,'BITPIX',BITPIX)
	Call HGETI4 (HEADER,'NAXIS',NAXIS)
	Call HGETI4 (HEADER,'NAXIS1',NAXIS1)
	NBPIX = BITPIX / 8
	NBR0 = NAXIS1 * NBPIX
	If (NAXIS .gt. 1) Then
	    Call HGETI4 (HEADER,'NAXIS2',NAXIS2)
	    NBR0 = NBR0 * NAXIS2
	    Endif

c  Set column limits and number of columns to print

	If (IX2 .ge. IX1) Then
	    IC1 = IX1
	    IC2 = IX2
	Else
	    IC2 = IX1
	    IC1 = IX2
	Endif
	If (IC1 .lt. 1) IC1 = 1
	If (IC2 .gt. NAXIS1) IC2 = NAXIS1
	NC = IC2 - IC1 + 1
	NBCOL = NC * NBPIX

c  Set row limits to print

	If (IY2 .ge. IY1) Then
	    IR1 = IY1
	    IR2 = IY2
	Else
	    IR2 = IY1
	    IR1 = IY2
	Endif
	If (IR1 .lt. 1) IR1 = 1
	If (IR2 .gt. NAXIS2) IR2 = NAXIS2

	If (VERBOSE) Then
	    Write(STRING,*) 'Printing rows',IR1,' -',IR2,' columns',IC1,' -',IC2
	    Call PSTRING (STRING)
	    Write(STRING,*) 'Image is',NAXIS1,' x',NAXIS2
	    Call PSTRING (STRING)
	    Endif

c  Print heading

	Write(STRING,*) 'NAXIS1=',NAXIS1
	Call PADNULL (STRING)
	Call PSTRING (STRING)
	If (BITPIX .eq. 8) Then
	    Write(STRING,'(4x,30I4)') (IC, IC=IC1, IC2)
	    Call PADNULL (STRING)
	    Call PSTRING (STRING)
	Elseif (BITPIX .eq. 16) Then
	    Write(STRING,'(4x,20I6)') (IC, IC=IC1, IC2)
	    Call PADNULL (STRING)
	    Call PSTRING (STRING)
	Elseif (BITPIX .eq. 32) Then
	    Write(STRING,'(4x,12I10)') (IC, IC=IC1, IC2)
	    Call PADNULL (STRING)
	    Call PSTRING (STRING)
	Endif

c  Print image section line by line

	Do 200 IR = IR2, IR1, -1
	    If (BITPIX .eq. 8) Then
		OFFSET = ((IR - 1) * NAXIS1) + IC1
		If (NC .gt. 30) NC = 30
		Call MOVEB (IMAGE,KLINE,NBCOL,OFFSET,0)
		Call SVEC12 (KLINE,JLINE,NC)
		Write(STRING,'(I4,30I4)') IR,(JLINE(I), I=1, NC),OFFSET
		Call PADNULL (STRING)
		Call PSTRING (STRING)
		Write(STRING,*) 'offset is', OFFSET,'$'
		Call PADNULL (STRING)
		Call PSTRING (STRING)
	    Elseif (BITPIX .eq. 16) Then
		OFFSET = (((IR - 1) * NAXIS1) + IC1) * 2
		If (NC .gt. 20) NC = 20
		Call MOVEB (IMAGE,JLINE,NBCOL,OFFSET,0)
		Write(STRING,'(I4,20I6)') IR,(JLINE(I), I=1, NC)
		Call PADNULL (STRING)
		Call PSTRING (STRING)
	    Elseif (BITPIX .eq. 32) Then
		OFFSET = (((IR - 1) * NAXIS1) + IC1) * 4
		If (NC .gt. 12) NC = 12
		Call MOVEB (IMAGE,ILINE,NBCOL,OFFSET,0)
		Write(STRING,'(I4,12I10)') IR,(ILINE(I), I=1, NC)
		Call PADNULL (STRING)
		Call PSTRING (STRING)
	    Endif
200	    Continue

	Return
	End
