c*** File fitslib/fitsrtab.f
c*** By Doug Mink, Center for Astrophysics
c*** January 5, 1995

	Subroutine FITSRTAB (INPATH, HEADER, TABLE, NBR)

	Character*(*) INPATH
c				Pathname for FITS tables file to read
	Character*(*) HEADER
c				Header for FITS tables file to read
	Character*(*) TABLE
c				FITS table
	Integer*4 NBR
c				Number of bytes read in table

	Integer*4 IFD,NBYTES,NBHEAD,IPOS
	Integer*4 NCHAR,NROWS,IER,LIN
	Character*20 TEMP

	Include 'header.cmb'

c  Open input file

	NBR = 0
	Call FITSRHEAD (INPATH, HEADER, NBHEAD)
	If (NBHEAD .lt. 2880) Then
	    Return
	    Endif

c  Make sure this file is really a FITS table file

	Call HGETC (HEADER,'XTENSION',TEMP)
	If (TEMP(1:5) .ne. 'TABLE') Then
	    Call VLEN (INPATH,LIN)
	    Write(*,150) INPATH(1:LIN)
150	    Format('FITSRTAB: "',A,'" is not a FITS Table file')
	    Stop
	    Endif

	Call OPENR (IFD,INPATH)
	Call SPOS (IFD,NBHEAD,IPOS)

c  Read the FITS table into memory all at once

	Call HGETI4 (HEADER,'NAXIS1', NCHAR)
	Call HGETI4 (HEADER,'NAXIS2', NROWS)
	NBYTES = NCHAR * NROWS
	Call SGETC (IFD,NBYTES,TABLE,NBR)
	Call SCLOSE (IFD,IER)

	Return
	End

c Apr 11 1991	If OPEN fails, try 3 more times before giving up
c Apr 19 1991	Call FITSRTOPEN to open file
c Apr 23 1991	Switch to stream I/O
c Apr 29 1991	Call FITSRHEAD to load and find length of header
c Jul 11 1991	Set LIN
c Jul 18 1991	Use standard IO instead of stream IO

c Jan  5 1995	If header cannot be read, return nbr=0
