c*** File fitslib/fitsrtline.f
c*** June 28, 1993
c*** By Doug Mink, Center for Astrophysics

	Subroutine FITSRTLINE (IFD, NBHEAD, TBUFF, IROW, NBLINE, LINE, NBREAD)

	Integer*4 IFD
c				File descriptor for FITS file
	Integer*4 NBHEAD
c				Number of bytes in FITS header
	Character*(*) TBUFF
c				FITS table
	Integer*4 IROW
c				Number of table row to read
	Integer*4 NBLINE
c				Number of bytes to read for this line
	Character*(*) LINE
c				One line of FITS table (returned)
	Integer*4 NBREAD
c				Number of bytes read for this line (returned)

	Integer*4 LBUFF,NBUFF,NLBUFF,IPOS,NBR
	Integer*4 OFFSET

	Include 'header.cmb'

	Common/RTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2
	Data OFFSET1/0/, OFFSET2/0/

	OFFSET = NBHEAD + (NBLINE * (IROW - 1))

c  Read a new buffer of the FITS table into memory if needed

	If ((OFFSET .lt. OFFSET1) .or. (OFFSET .gt. OFFSET2)) Then
	    LBUFF = Len (TBUFF)
	    NLBUFF = LBUFF / NBLINE
	    NBUFF = NLBUFF * NBLINE
	    IPOS = 0
	    Call SPOS (IFD,OFFSET,IPOS)
	    Call SGETC (IFD,NBUFF,TBUFF,NBR)
	    If (NBR .lt. NBLINE) Then
		NBREAD = NBR
		Return
		Endif
	    OFFSET1 = OFFSET
	    OFFSET2 = OFFSET + NBR - 1
	    Endif

	LINE(1:NBLINE) = TBUFF(OFFSET-OFFSET1+1:OFFSET-OFFSET1+NBLINE)
	NBREAD = NBLINE

	Return
	End

	Subroutine FITSRTLSET

	Common/RTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2

	OFFSET1 = 0
	OFFSET2 = 0
	Return
	End

c Apr 23 1991	Switch to stream I/O
c Jul 24 1991	Switch back to standard I/O; fix numerous bugs

c Feb 25 1993	Drop unused variable ier
c Jun 28 1993	Add subroutine to reset buffer pointers
