c*** File fitslib/fitsrtopen.f
c*** March 4, 1997
c*** By Doug Mink, Center for Astrophysics

	Subroutine FITSRTOPEN (INPATH, HEADER, NBSKIP, IFD)

	Character*(*) INPATH
c				Pathname for FITS tables file to read
	Character*(*) HEADER
c				Header for FITS tables file to read
	Integer*4 NBSKIP
c				Number of bytes before data starts
c				This includes the first, simple header block
c				and any previous header/data units
	Integer*4 IFD
c				File descriptor for FITS tables file

	Integer*4 LIN
	Integer*4 NTRY, IPOS
	Character*10 TEMP

	Common/RTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2

	Include 'header.cmb'
	Include 'fitshead.cmb'

c  Read FITS header from input file
100	Call FITSRHEAD (INPATH, HEADER, NBSKIP)
	If (NBSKIP .eq. 0) Then
	    Call VLEN (INPATH,LIN)
	    Write(*,110) INPATH(1:LIN)
110	    Format('FITSRTOPEN: "',A,'" is not a FITS Table file')
	    Stop
	    Endif

c  Make sure this file is really a FITS table file
	Call ZSTRING (TEMP)
	Call HGETC (HEADER,'XTENSION',TEMP)
	If ((TEMP(1:5) .ne. 'TABLE') .and. (TEMP(1:8) .ne. 'BINTABLE')) Then

c  Try next header/data unit if this is not a table
	    If (FITSHDU .lt. 2) Then
		FITSHDU = 2
	    Else
		FITSHDU = FITSHDU + 1
	    Endif
	    Go to 100
	    Endif

c  Open input file
	NTRY = 0
200	IFD = -1
	Call OPENR (IFD,INPATH)
	Call VLEN (INPATH,LIN)
	If (IFD .lt. 3) Then
	    If (NTRY .lt. 3) Then
		NTRY = NTRY + 1
		Go to 200
	    Else
		Write(*,205) INPATH(1:LIN)
205		Format('FITSRTOPEN:  Cannot read file "',A,'"')
		Stop
	    Endif
	Elseif (VERBOSE) Then
	    Write(*,206) INPATH(1:LIN)
206	    Format('FITSRTOPEN:  Input file "',A,'"opened')
	Endif

c  Skip to start of table data
	Call SPOS (IFD,NBSKIP,IPOS)

	Return
	End

c Apr 23 1991	Switch to stream I/O
c Jul 24 1991	Switch back to standard I/O
c Dec 18 1991	Reset OFFSETs for FITSRTLINE

c Feb 12 1992	Print file name for header reading error

c Feb 25 1993	Drop unused variables nfile and tape

c Jan 29 1997	Implement FITS binary tables and multiple HDUs
c Mar  4 1997	Use FITSRHEAD to read header
