c*** File fitslib/fitswcs.f
c*** April 16, 1997
c*** By Doug Mink, Center for Astrophysics

c--- Set search region from FITS or IRAF image header

	Subroutine FITSWCS (PARMS,HEADER)

	Character*(*) PARMS
c				Parameter string to run calling program
	Character*(*) HEADER
c				FITS header

	Logical VERBOSE
	Integer*4 IWCS, I, IDG
	Real*8 CRA,CDEC,DRA,DDEC,HRA,HDEC,R0,CPHI,CTHETA,DPHI,DTHETA
	Real*8 DECPM,RAPM,ROTATE
	Character*64 TEMP
	Character*16 PROGRAM
	Character*1 MAPCOOR

	Include 'star.cmb'

	Call WCSINIT (HEADER,IWCS)
	Call WCSSIZE (IWCS,CRA,CDEC,DRA,DDEC,TEMP)
	Call TPGET (PROGRAM)

c  Convert image center to current coordinate system

	Call PGETC (PARMS,'MAPCOOR',MAPCOOR)
	If ((TEMP(1:1) .eq. 'B') .or. (TEMP(1:3) .eq. 'FK4')) Then
	    If (MAPCOOR .eq. 'J') Then
		RAPM = 0.d0
		DECPM = 0.d0
		IDG = 0
		Call JPFK425 (CRA,CDEC,RAPM,DECPM,IDG)
		Endif
	Else
	    If (MAPCOOR .eq. 'B') Then
		RAPM = 0.d0
		DECPM = 0.d0
		IDG = 0
		Call JPFK524 (CRA,CDEC,RAPM,DECPM,IDG)
		Endif
	Endif

c  Set image center

	Call RCONH (CRA,HRA)
	Call PPUTR8 (PARMS,'CRA',HRA)
	Call DCONH (CDEC,HDEC)
	Call PPUTR8 (PARMS,'CDEC',HDEC)
	If (PROGRAM(1:6) .eq. 'SKYMAP') Then
	    Call RCOND (HRA,CTHETA)
	    Call PPUTR8 (PARMS,'CTHETA',CTHETA)
	    Call PPUTR8 (PARMS,'UCT',CTHETA)
	    Call DCOND (HDEC,CPHI)
	    Call PPUTR8 (PARMS,'CPHI',CPHI)
	    Call PPUTR8 (PARMS,'UCP',CPHI)
	    ROTATE = 0.d0
	    Call HGETR8 (HEADER,'CROTA1',ROTATE)
	    Call PPUTR8 (PARMS,'ROTATE',ROTATE)
	    Endif

c  Set image width and height

	DRA = DRA / Dcos (CDEC)
	Call RCONH (DRA,HRA)
	Call PPUTR8 (PARMS,'DRA',HRA)
	Call DCONH (DDEC,HDEC)
	Call PPUTR8 (PARMS,'DDEC',HDEC)
	Call PPUTR8 (PARMS,'DBOX',0.d0)
	If (PROGRAM(1:6) .eq. 'SKYMAP') Then
	    Call RCOND (HRA,DTHETA)
	    Call PPUTR8 (PARMS,'DTHETA',DTHETA)
	    Call PPUTR8 (PARMS,'UDT',DTHETA)
	    Call DCOND (HDEC,DPHI)
	    Call PPUTR8 (PARMS,'DPHI',DPHI)
	    Call PPUTR8 (PARMS,'UDP',DPHI)
	    Call PPUTR8 (PARMS,'UDBOX',0.d0)
	    Endif

c  Set image projection

	Call HGETC (HEADER,'CTYPE1',TEMP)
	If (Index (TEMP,'SIN') .gt. 1) Then
	    Call PPUTC (PARMS,'MAPPROJ','CYLINDRICAL')
	Elseif (Index (TEMP,'AIT') .gt. 1) Then
	    Call PPUTC (PARMS,'MAPPROJ','AITOFF')
	Elseif (Index (TEMP,'MER') .gt. 1) Then
	    Call PPUTC (PARMS,'MAPPROJ','MERCATOR')
	Else
	    Call PPUTC (PARMS,'MAPPROJ','GNOMONIC')
	Endif

c  Set object name to image filename

	TEMP = 'image'
	Call PGETC (PARMS,'IMFILE',TEMP)
	I = Index (TEMP,'/')
	If (I .le. 0) Then
	    OBJNAME = TEMP
	Else
	    TEMP = TEMP(I+1:)
150	    I = Index (TEMP,'/')
	    If (I .gt. 0) Then
		TEMP = TEMP(I+1:)
		Go to 150
		Endif
	    OBJNAME = TEMP
	Endif

	VERBOSE = .false.
	Call PGETL (PARMS,'VERBOSE',VERBOSE)
	If (VERBOSE) Then
	    R0 = 0.d0
	    Call OCSTRN (TEMP,CRA,CDEC,R0,.true.,'T',3)
	    Write(*,*) 'Image center at ',TEMP
	    Call OCSTRN (TEMP,DRA,DDEC,R0,.true.,'T',3)
	    Write(*,*) '   Half-size is ',TEMP
	    Endif

	Return
	End

c Jan 16 1996	New subroutine
c May 15 1996	Write THETA and PHI, if called in SKYMAP
c Jun 18 1996	Add ROTATE if called in SKYMAP
c Jun 28 1996	Convert center to SKYMAP coordinate system, not vice versa

c Apr 16 1997	Declare undeclared variable rotate
