c*** File fitslib/fitswrite.f
c*** December 5, 1996
c*** By Doug Mink

c--- Write FITS header and data after opening a data file
c    Print extra information if VERBOSE in /HEADER/ common is set.

	Subroutine FITSWRITE (FNAME,HSTRING,IMAGE,NW)

	Character*(*) FNAME
c				File name
	Character*(*) HSTRING
c				Header string
	Integer*4 IMAGE(*)
c				Image array
	Integer*4 NW
c				Number of image bytes written (returned)
c				Value of 0 returned if unsuccessful

	Integer*4 IFIL
c				UNIX file from which to read

	Logical BSWAP
	Integer*4 NC, NAXIS, NAXIS1, NAXIS2, BITPIX, NBPIX, IEND
	Integer*4 NAXIS3,NLEFT,NW1,LFNAM,NBYTES,NBHEAD

	Common/FITSW/ ZEROES
	Integer*4 ZEROES(720)

	Include 'header.cmb'

	Data ZEROES/720*0/

	Call ESET

c  Open data file, returning if not possible

	IFIL = -2
	Call OPENW (IFIL,FNAME)
	Call VLEN (FNAME,LFNAM)
	IF (IFIL .lt. 3) Return

c  Compute number of bytes to write

	Call HSEARCH (HSTRING,'END',IEND)
	NC = IEND + 3
	NBHEAD = 2880 * (NC / 2880)
	If (NBHEAD .lt. NC) NBHEAD = NBHEAD + 2880

c  Write FITS header

	Call SPUTC (IFIL,NBHEAD,HSTRING,NW)
	If (NW .lt. NBHEAD) Then
	    Write(*,105) NW,NBHEAD,FNAME
105	    Format('FITSWRITE: Only',I5,'/',I5,' bytes written to "',A,'"')
	    Call PCHAR (13)
	    Return
	    Endif

	If (VERBOSE) Write(*,110) NC,FNAME
110	Format('FITSWRITE:',I5,'-byte header written to file "',A,'"')

c  Compute number of bytes in image

	Call HGETI4 (HSTRING,'BITPIX',BITPIX)
	Call HGETI4 (HSTRING,'NAXIS',NAXIS)
	Call HGETI4 (HSTRING,'NAXIS1',NAXIS1)
	NBPIX = BITPIX / 8
	If (NBPIX .lt. 0) NBPIX = -NBPIX
	NBYTES = NAXIS1 * NBPIX
	If (NAXIS .gt. 1) Then
	    Call HGETI4 (HSTRING,'NAXIS2',NAXIS2)
	    NBYTES = NBYTES * NAXIS2
	    Endif
	If (NAXIS .gt. 2) Then
	    Call HGETI4 (HSTRING,'NAXIS3',NAXIS3)
	    NBYTES = NBYTES * NAXIS3
	    Endif

c  Swap data bytes to FITS format on Vax & Decstation

	Call BYTEORDER (BSWAP)
	If (BSWAP) Then
	    If (BITPIX .eq. -32) Then
		Call SSWAP4 (IMAGE,NBYTES)
	    Elseif (BITPIX .eq. 32) Then
		Call SSWAP4 (IMAGE,NBYTES)
	    Elseif (BITPIX .eq. 16) Then
		Call SSWAP2 (IMAGE,NBYTES)
	    Elseif (BITPIX .eq. -64) Then
		Call SSWAP2 (IMAGE,NBYTES)
	    Endif
	    If (VERBOSE) Then
		Write(*,130) NBYTES,FNAME(1:LFNAM)
130		Format('FITSREAD:',I8,' bytes swapped from file "',A,'"')
		Endif
	    Endif

c  Write data

	Call SPUT (IFIL,NBYTES,IMAGE,NW)
	If (NBYTES .gt. NW) Then
	    Write(*,135) NW,NBYTES,FNAME
135	    Format('*** FITSWRITE: ',I7,' < ',I7,' bytes in file "',A,'"')
	    NW = 0
	    Endif

	NLEFT = 2880 * ((NW / 2880) + 1) - NW
	If (NLEFT .lt. 2880) Then
	    Call SPUT (IFIL,NLEFT,ZEROES,NW1)
	    NW = NW + NW1
	    Endif
	If (VERBOSE) Then
	    Write(*,140) NW, FNAME
140	    Format('FITSWRITE: ',I7,' bytes written to file "',A,'"')
	    Endif

	Return
	End

c Mar  7 1991	Add byte-swapping for BITPIX = -32 and -64
c Sep 25 1991	Take care of negative BITPIX for floating point images

c Jan 10 1992	Make separate DEC and Sun versions of this subroutine

c Feb 25 1993	Check byte order with BYTEORDER

c Dec  5 1996	Print only total number of bytes written
