c*** File fitslib/fitswthead.f
c*** By Doug Mink, Center for Astrophysics
c*** March 18, 1994

	Subroutine FITSWTHEAD (OUTPATH,HEADER,NK,KNUM,KNAME,KFIRST,KLAST,KFORM)

	Character*(*) OUTPATH
c				Pathname for FITS tables file to written
	Character*(*) HEADER
c				Header for FITS tables file to written
	Integer*4 NK
c				Number of keywords to use
	Integer*4 KNUM(*)
c				Indices of desired keywords
	Character*(*) KNAME(*)
c				List of keywords to use
	Integer*4 KFIRST(*)
c				Starting postion of desired keywords (returned)
	Integer*4 KLAST(*)
c				Final postion of desired keywords (returned)
	Character*(*) KFORM(*)
c				Formats of keywords in file (returned)

	Integer*4 PFIRST(100)
c				Indices of first characters of table entries
	Integer*4 PLAST(100)
c				Indices of last characters of table entries
	Character*10 PFORM(100), TFORM, TFORM0
c				Formats of table entries
	Character*10 PNAME(100), TNAME
c				Names of table entries
	Integer*4 LPNAM(100)
c				Length of name for each field
	Integer*4 LIN,IH0,NFIELDS,NBHEAD
	Integer*4 NLEFT,IFIELD,IPT,LF0,LFL,LFIELD,IER,IK,LN,LNM
	Character*20 TEMP
	Character*100 STRING
	Character*2880 FHEAD
	Logical TVERB

	Include 'header.cmb'

c  Read FITS header from input file

	Call FITSRHEAD (INPATH, HEADER, NBHEAD)

c  Make sure this file is really a FITS table file

	Call HGETC (HEADER,'XTENSION',TEMP)
	If (TEMP(1:5) .ne. 'TABLE') Then
	    Call VLEN (INPATH,LIN)
	    Write(*,150) INPATH(1:LIN)
150	    Format('FITSRTAB: "',A,'" is not a FITS Table file')
	    Stop
	    Endif

c  Set up table for access to individual fields

	Call HGETI4 (HEADER,'TFIELDS',NFIELDS)
	If (VERBOSE) Write(*,*) NFIELDS,' fields per table entry'
	IH0 = 1
	NLEFT = NK
	TVERB = VERBOSE
	VERBOSE = .false.
	Do 170 IFIELD = 1, NFIELDS
	    If (NLEFT .le. 0) Go to 200
	    If (IFIELD .lt. 10) Then
		Write(TEMP,161) IFIELD
161		Format('TBCOL',I1)
	    Elseif (IFIELD .lt. 100) Then
		Write(TEMP,162) IFIELD
162		Format('TBCOL',I2)
	    Else
		Write(TEMP,163) IFIELD
163		Format('TBCOL',I3)
	    Endif
	    Call HSEARCH (HEADER(IH0:),TEMP,IPT)
	    Call HGETI4 (HEADER(IH0:),TEMP,PFIRST(IFIELD))
	    TEMP(2:5) = 'FORM'
	    Call HGETC (HEADER(IH0:),TEMP,PFORM(IFIELD))
	    Call VLEN (PFORM(IFIELD),LF0)
	    LFL = Index (PFORM(IFIELD),'.') - 1
	    If (LFL .lt. 0) LFL = LF0
	    TFORM = PFORM(IFIELD)
	    Call ASCBIN (LFL-1,TFORM(2:),-14,LFIELD,IER)
	    PLAST(IFIELD) = PFIRST(IFIELD) + LFIELD - 1
	    TEMP(2:5) = 'TYPE'
	    Call HGETC (HEADER(IH0:),TEMP,PNAME(IFIELD))
	    Call PADNULL (PNAME(IFIELD))
	    Call VLEN (PNAME(IFIELD),LPNAM(IFIELD))
c	    If (VERBOSE) Then
c		LN = LPNAM(IFIELD)
c		Call VLEN (PFORM(IFIELD),LF0)
c		TNAME = PNAME(IFIELD)
c		If (VERBOSE) Write(*,165) IFIELD,TNAME(1:LN),
c     1		    TFORM(1:LF0),PFIRST(IFIELD),PLAST(IFIELD)
c165		Format(I3,1x,A8,1x,A8,I5,' -',I5)
c		Endif
	    IH0 = IH0 + IPT - 1
170	    Continue

c  Set up table for access to desired fields

c   Open output keyword file, checking to see whether it can be written

200	VERBOSE = TVERB
	STRING = 'Keywords from $'
	Call CONSTR (STRING,INPATH(1:LIN))
	Call PADNULL (STRING)
	If (VERBOSE) Call PSTRING (STRING)
	Do 210 IK = 1, NK
	    If (KNUM(IK) .le. 0) Then
		TEMP = KNAME(IK)
		Do 205 IFIELD = 1, NFIELDS
		    TNAME = PNAME(IFIELD)
		    LN = LPNAM(IFIELD)
		    If (TEMP(1:LN) .eq. TNAME(1:LN)) Then
			KNUM(IK) = IFIELD
			Go to 206
			Endif
205		    Continue
206		IFIELD = KNUM(IK)
	    Else
		IFIELD = KNUM(IK)
	    Endif
	    KFIRST(IK) = PFIRST(IFIELD)
	    KLAST(IK) = PLAST(IFIELD)
	    KNAME(IK) = PNAME(IFIELD)
	    TNAME = KNAME(IK)
	    LNM = LPNAM(IFIELD)

c  Set input format for this field

	    TFORM0 = '('
	    Call PADNULL (TFORM0)
	    Call CONSTR (TFORM0,PFORM(IFIELD))
	    Call CONSTR (TFORM0,')')
	    Call VLEN (TFORM0, LF0)
	    KFORM(IK) = TFORM0

	    If (VERBOSE) Then
		Write(STRING,208) IK,KNUM(IK),TNAME(1:LNM),TFORM0(1:LF0),
     1				  KFIRST(IK),KLAST(IK)
208		Format(I3,I4,1x,A8,1x,A8,I5,' -',I5)
		Call PADNULL (STRING)
		Call PSTRING (STRING)
		Endif
210	    Continue

	Return
	End

c Apr 19 1991	Call FITSRTOPEN to read FITS header
c Apr 23 1991	Switch to stream I/O
c Apr 29 1991	Call FITSRHEAD to read FITS header
c Jul 11 1991	Set LIN

c Jan 27 1993	Drop all reference to keyword file; turn off VERBOSE
