c*** File fitslib/hread.f
c*** March 21, 1991
c*** By Doug Mink

c--- Read FITS header after opening a data file
c    Note settings of /HEADER/ common.

	Subroutine HREAD (IFIL,FNAME,HSTRING,NR)

	Integer*4 IFIL
c				UNIX file from which to read (returned)
	Character*(*) FNAME
c				File name
	Character*(*) HSTRING
c				Header string (returned)
	Integer*4 NR
c				Number of characters actually read (returned)
c				Value of 0 returned if unsuccessful

	Character NULL*1
	Logical EXTEND
	Integer*4 IEND,I0,IHEAD0,IHEAD1,LMAX,LREC,JEND,IEXT,I

	Include 'header.cmb'

	NULL = Char (0)

c  Initialize header string to NULL

	LMAX = Len (HSTRING)
	Do 40 I = 1, LMAX
40	   HSTRING(I:I) = NULL

c  Open data file, returning if not found

	IFIL = -2
	NR = 0
	Call OPENR (IFIL,FNAME)
	IF (IFIL .lt. 3) Return

c  Read FITS header

	IHEAD1 = 2880
	LREC = 2880
	JEND = 0
	Call SGETC (IFIL,LREC,HSTRING,NR)
50	If (NR .lt. 2) Then
	   Call ESET
	   Write(*,60) NR,FNAME
60	   Format('HREAD:',I3,' bytes in file "',A,'"')
	   NR = 0
	   Return
	   Endif

c  Find END and pad rest of header string with NULLs

	I0 = 1
	Call HSEARCH (HSTRING,'END',IEND)
	If (IEND .gt. 0) Then
	    Call HSEARCH (HSTRING,'EXTEND',IEXT)
	    EXTEND = .false.
	    If (IEXT .gt. JEND) Call HGETL (HSTRING,'EXTEND',EXTEND)
	    If (EXTEND) Then
		IHEAD0 = IEND
		IHEAD1 = IEND + LREC - 1
		If (IHEAD1 .gt. LMAX) Then
		    Call ESET
		    Write(*,105) FNAME
		    NR = 0
		    Return
		    Endif
		Call SGETC (IFIL,LREC,HSTRING(IHEAD0:IHEAD1),NR)
		JEND = IEND
		Go to 50
	    Else
		I0 = IEND + 80
		Do 100 I = I0, LMAX
100		    HSTRING(I:I) = NULL
	    Endif

	Else
	    IHEAD0 = IHEAD1 + 1
	    IHEAD1 = IHEAD1 + LREC
	    If (IHEAD1 .gt. LMAX) Then
		Call ESET
		Write(*,105) FNAME
105		Format('HREAD: No header END in file "',A,'"')
		NR = 0
		Return
		Endif
	    Call SGETC (IFIL,LREC,HSTRING(IHEAD0:IHEAD1),NR)
	    Go to 50
	Endif

	If (VERBOSE) Then
	    Call ESET
	    Write(*,120) IHEAD1,FNAME
120	    Format('HREAD:',I5,'-byte header read from file "',A,'"')
	    Endif
	NR = IHEAD1

	Return
	End

c Apr 11 1985	Use SGETC instead of SGET, eliminating assignment

c May  7 1985	Clean up diagnostic messages

c Nov 12 1985	Format error message

c Dec 19 1986	Read FITS headers one 29880-byte block at a time

c May 20 1987	Use Fortran's length as maximum for header

c Jul 14 1987	Drop $ as termination character in HSEARCH call

c Jul 22 1987	Drop length argument from HSEARCH

c Feb  9 1990	Add code to read extended headers
