/*** File fitslib/imhdr.h
 *** May 13, 1996
 *** By Doug Mink, Harvard-Smithsonian Center for Astrophysics

     IRAF Image Header Definitions 
 */

  short IRAFBUFF(15000)

struct irafhead {
  float HRDUM;		/* To align labelled common */
  char MAGIC[12];	/* Contains "imhdr" or "impix" */
  int HLEN;		/* Length of image header */
  int PIXTYPE;		/* Datatype of the pixels */
  int NAX;		/* Number of dimensions */
  int AXLEN[7];		/* Length of dimensions 1-7 */
  int AXPLEN[7];	/* Length of 1st dimension (as stored) */
  int SSMTYPE;		/* Type of subscript mapping */
  int LUTOFF;		/* Offset to subscript map luts */
  int PIXOFF;		/* Offset of the pixels */
  int HGMOFF;		/* Offset of hgm pixels */
  int BLIST;		/* Offset of bad pixel list */
  int SZBLIST;		/* Size of bad pixel list */
  int NBPIX;		/* Number of bad pixels */
  int CTIME;		/* Time of image creation */
  int MTIME;		/* Time of last modify */
  int IMTIME;		/* Time min, max computed */
  float IMMAX;		/* Maximum pixel value */
  float IMMIN;		/* Minimum pixel value */
  int IMDUM;		/* To take up space */
  int HGM[20];		/* Histogram structure */
  int CTSTRUCT[50];	/* Coordinate transform structure */
  short PIXFILE[80];	/* Name of pixel storage file */
  short HDRFILE[80];	/* Name of header storage file */
  short TITLE[80];	/* Image name string */
  short HISTORY[512];	/* History comment string */

c Dec 11 1995	New common
c May 13 1996	Increase irafbuff from 10000 to 15000
