/*** File imhdr.h
 *** December 12, 1995
 *** by Doug Mink, Harvard-Smithsonian Center for Astrophysics

     IRAF Image Header Definitions 
 */

struct IRAFhead {
  float hrdum;		/* to align labelled common */
  char magic[12];	/* contains "imhdr" or "impix" */
  int hlen;		/* length of image header */
  int pixtype;		/* datatype of the pixels */
  int nax;		/* number of dimensions */
  int axlen[7];		/* length of dimensions 1-7 */
  int axplen[7];	/* length of 1st dimension (as stored) */
  int ssmtype;		/* type of subscript mapping */
  int lutoff;		/* offset to subscript map luts */
  int pixoff;		/* offset of the pixels */
  int hgmoff;		/* offset of hgm pixels */
  int blist;		/* offset of bad pixel list */
  int szblist;		/* size of bad pixel list */
  int nbpix;		/* number of bad pixels */
  int ctime;		/* time of image creation */
  int mtime;		/* time of last modify */
  int imtime;		/* time min, max computed */
  float immax;		/* maximum pixel value */
  float immin;		/* minimum pixel value */
  int imdum;		/* to take up space */
  int hgm[20];		/* histogram structure */
  int ctstruct[50];	/* coordinate transform structure */
  short pixfile[80];	/* name of pixel storage file */
  short hdrfile[80];	/* name of header storage file */
  short title[80];	/* image name string */
  short history[512];	/* history comment string */
  };
