c*** File iolib/enterc.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine ENTERC (PROMPT,ITYPE,CVAL)

c	Accept prompted input from a terminal (UNIX standard I/O)
c	This version of ENTER expects a Character-type argument (CVAL)
c	and will return unpredictable results if not called with one.

c	CR with no entry returns current value,
c	LF  reprompts,
c	BACKSPACE deletes and backspaces cursor,
c	DELETE (RUBOUT) deletes and echos deleted material inside '<>',
c	ESC (ctrl-shift-K) or ctrl-C exits from program
c	ctrl-R reprompts with previously entered characters displayed.

	Character*(*) PROMPT
c		String printed to prompt input
c		If not null, it must be terminated by a $ (dollar sign)
c		For command, '? ' is added.
c		For single character, ' : ' is added.
c		Otherwise, ' = ' is added and a CR terminates entry.

	Integer*4 ITYPE
c		-1: command (single character response (CR without LF printed)
c		    Lower case letters are converted to upper case.
c		0: 1-50 characters in PROMPT printed with CR LF
c		1: single character, returned as single byte (CR LF printed)
c		2-99: Character string length, padded with spaces
c		101-199: Character string length (+100), padded with NULLs
c		201-236: number of single characters (200 added)
c			returned in array of 36 (A-Z,0-9) Integer*2
c			with array positions corresponding to letter
c			or number entered set to one.  Array is not
c			zeroed on entry.
c			Lower case letters are treated as upper case.
c		301-399: Character string length (+300), padded with NULLs
c			 Lower case letters are converted to upper case.

	Character*(*) CVAL
c		Address for returned character string

	Character*1 ICR
	Character PRMPT*80,JCHR*1,LINE*100
	Integer LPRMPT,ICHR,MCHAR,ITP,NC,NCHAR

	ICR = Char (13)

c  Set maximum input string length

	If (ITYPE .gt. 300) Then
	    MCHAR = ITYPE - 300
	    If (MCHAR .gt. 99) MCHAR = 99
	Elseif (ITYPE .gt. 200) Then
	    MCHAR = ITYPE - 200
	Elseif (ITYPE .gt. 100) Then
	    MCHAR = ITYPE - 100
	Elseif (ITYPE .gt. 0) Then
	    MCHAR = ITYPE
	Elseif (ITYPE .eq. -1) Then
	    MCHAR = 1
	Else
	    If (ITYPE .lt. -30) Then
		Call PSTRING ('ENTERC: Use ENTER for logical values')
	    Else
		Call PSTRING ('ENTERC:  Use ENTER for numeric values')
	    Endif
	    Return
	Endif
	NCHAR = 0

c  Set standard input to raw and suppress echo

	Call RSET

c  Find length of prompt

10	Call VLEN (PROMPT,LPRMPT)
	PRMPT(1:LPRMPT) = PROMPT(1:LPRMPT)

c  Print prompt terminator (?, :, or =)

	If (ITYPE .eq. -1) Then
	    PRMPT(LPRMPT+1:LPRMPT+2) = '? '
	    LPRMPT = LPRMPT + 2
	Elseif (MCHAR .eq. 1) Then
	    PRMPT(LPRMPT+1:LPRMPT+3) = ' : '
	    LPRMPT = LPRMPT + 3
	Elseif (ITYPE .eq. 0) Then
	    Call PNEWLINE
	    Return
	Else
	    PRMPT(LPRMPT+1:LPRMPT+3) = ' = '
	    LPRMPT = LPRMPT + 3
	Endif

c  Print prompt

	Call PCHRS (LPRMPT,PRMPT)

c  Print entry thus far

	If (NCHAR .gt. 0) Then
	   Call PCHRS (NCHAR,LINE)
	   Go to 100
	   Endif

c  Initialize input string

	NCHAR = 0
	Call ZFILLC (LINE,100)

c  Read single character

100	Call SGCHRS (ITYPE,LINE,NCHAR,ICHR)

c	If ESC or ^C, stop

	If (ICHR .eq. 27) Then
	    Go to 900
	Elseif (ICHR .eq. 3) Then
	    Go to 910

c	If LF, print current value and reprompt

	Elseif (ICHR .eq. 10) Then
	   NCHAR = 0
	   Go to 400

c	If Control-R, reprompt and display current line so far

	Elseif (ICHR .eq. 18) Then
	   Call PNEWLINE
	   Go to 10

	Endif

c  Decode entry

	If (NCHAR .gt. 0) Then
	    If (ITYPE .eq. -1) Then
		Call PCHRS (1,ICR)
	    Else
		Call PNEWLINE
	    Endif
	    CVAL = LINE
	    Return
	    Endif

c  Print entry if default or requested

400	NC = NCHAR
	LINE = CVAL
	Call PADNULL (LINE)
	Call VLEN (LINE,NCHAR)
	If ((ICHR .eq. 10) .and. (NC .le. 0)) Then
	    Call PCHRS (NCHAR,LINE)
	    Go to 100
	Else
	    Call PCHRS (1,' ')
	    If (ITYPE .ne. -1) Call PCHRS (1,'=')
	    Call PCHRS (NCHAR,LINE)

c	Add carriage return and linefeed

	    If (ITYPE .eq. -1) Then
		Call PCHRS (1,ICR)
	    Else
		Call PNEWLINE
	    Endif

c	Return to calling program unless reprompting
	    If ((ICHR .eq. 10) .or. (ICHR .eq. 18)) Go to 10
	    Return
	Endif

c  Terminate program after verifying intention to so do

900	PRMPT = '<escape>'
	Call PCHRS (8,PRMPT)
	Go to 920

910	PRMPT = '<ctrl-C>'
	Call PCHRS (8,PRMPT)

920	Call PNEWLINE
	PRMPT = 'Enter "y" if you really want to stop this program : '
	Call PCHRS (52,PRMPT)
	ITP = 301
	NC = 0
	JCHR = 'N'
	Call SGCHRS (ITP,JCHR,NC,ICHR)
	Call PNEWLINE
c	Write(*,*) JCHR,ICHR
	Call PNEWLINE
	If ((JCHR .eq. 'Y') .or. (JCHR .eq. 'y')) Then
	    Stop
	Else
	    Go to 10
	Endif
	End

c Jan 25 1985	Don't redisplay prompt on LF with no new entry

c May 19 1987	Change meaning of IER from ASCBIN to 1=OK
c Jul 13 1987	Call VLEN to compute prompt length
c Aug 12 1987	Minimize number of output calls (regroup prompt)
c Nov  3 1987	Parse line in C subroutine for speed

c Sep 12 1988	Fix call to SGCHRS in abort section

c Jun 21 1989	Fix abort code by dropping ICHR-JCHR Equivalence

c Jan 26 1990	Fix bug so default is set properly

c Feb 22 1993	Declare undeclared variables itp, nc, and nchar
