c*** File iolib/fopena.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine FOPENA (IDEV, FNAME)

c--- Open file to append buffered writing

	Integer*4 IDEV
c			UNIX file descriptor (returned)
c			If =-2 on entry, then there will be no request
c			for a new file name in case of an error, and
c			IDEV will be unchanged on return in that event.
	Character*(*) FNAME
c			File pathname
c			If error condition arises and IDEV is not =-2, this
c			subroutine will request a new file name from the user.

	Character FNAME0*64
	Integer*4 IER,IER1,IER2,IDEV0,I,LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for write permission and see if it's an executable 
c  file.  If write-protected, print error message.  If IDEV=-2 on entry,
c  bail out; otherwise, prompt user for new file name and try again.

	If (IER .eq. 0) then
	   Call SSWRIT (FNAME,IER1)
	   Call ESET
	   If (IER1 .eq. -1)
     1	      Write(*,*) 'FOPENA: File "',FNAME,'" is write-protected'
	   Call SSEXEC (FNAME,IER2)
	   If (IER2 .eq. 0)
     1	      Write(*,*) 'FOPENA: File "',FNAME,'" is executable'
	   If ((IER1 .eq. -1) .or. (IER2 .eq. 0)) then
	      If (IDEV .eq. -2) Then
	         Return
	      Else
	         Go to 100
	      Endif
	   Else
	      Call SFOPEN (IDEV0,3,FNAME)
	      If (IDEV0 .eq. -1) Then
	         Call ESET
	         Write(*,*) 'FOPENA: File "',FNAME,'" cannot be opened'
	         If (IDEV .eq. -2) Then
	            Return
	         Else
	            Go to 100
	         Endif
	      Else
	         IDEV = IDEV0
	         Return
	      Endif
	   Endif

c  If file does not exist, create it.

	Else
	   Call SFOPEN (IDEV0,2,FNAME)
	   If (IDEV0 .eq. -1) then
	      Call ESET
	      Write(*,*) 'FOPENA: File "',FNAME,'" not found; not creatable'
	      If (IDEV .eq. -2) Then
	         Return
	      Else
	         Go to 100
	      Endif
	   Else
	      IDEV = IDEV0
	      Return
	   Endif
	Endif

c  Enter new file name

100	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Jun 21 1985	Use Character filenames in SSx and SFOPEN calls

c Jan 22 1988	Replace PADSTR call with PADNULL

c Oct  5 1990	Fix bug concerning error return when write-protected

c Jul 11 1991	Eliminate unnecessary Return statement

c Feb 22 1993	Declare undeclared variables i and lfn
