c*** File iolib/fopenw.f
c*** June 10, 1993
c*** By Dick French and Doug Mink

	Subroutine FOPENW (IDEV, FNAME)

c--- Open file for buffered writing

	Integer*4 IDEV
c			UNIX file descriptor (returned)
c			If =-2 on entry, there will be no printed error
c			messages, and IDEV will be unchanged on return.
	Character*(*) FNAME
c			Null-terminated file pathname
c			If error condition arises and IDEV is not =-2, this
c			subroutine will request a new file name from the user.

	Character FNAME0*64
	Integer*4 IER,IER1,IER2,IDEV0,I,LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for write permission and see if it's an executable 
c  file.  If write-protected, print error message.  If IDEV=-2 on entry,
c  bail out; otherwise, prompt user for new file name and try again.

	If (IER .eq. 0) then
	    Call SSWRIT (FNAME,IER1)
	    Call ESET
	    If ((IER1 .eq. -1) .and. (IDEV .gt. -2)) Write(*,20) FNAME
20		Format('OPENW: File "',A,'" is write-protected')
	    Call SSEXEC (FNAME,IER2)
	    If ((IDEV .gt. -2) .and. (IER2 .eq. 0)) Write(*,30) FNAME
30		Format('OPENW: File "',A,'" is executable')
	    If (IER1 .eq. -1) then
		If (IDEV .le. -2) Then
		    Return
		Else
		    Go to 100
		Endif
	    Else
		Call SFOPEN (IDEV0,1,FNAME)
	 	If (IDEV0 .eq. -1) Then
		    If (IDEV .le. -2) Then
			Return
		    Else
			Call ESET
			Write(*,40) FNAME
40			Format('OPENW: File "',A,'" cannot be opened')
			Go to 100
		    Endif
		Else
		    IDEV = IDEV0
		    Return
		Endif
	    Endif

c  If file does not exist, create it.

	Else
	    Call SFOPEN (IDEV0,2,FNAME)
	    If(IDEV0.eq.-1) then
		If (IDEV .le. -2) Then
		    Return
		Else
		    Call ESET
		    Write(*,50) FNAME
50		    Format('OPENW: File "',A,'" not found; not creatable')
		    Go to 100
		Endif
	    Else
		IDEV=IDEV0
		Return
	    Endif
	Endif

c  Enter new file name

100	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	    FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Jun 21 1985	Use Character filenames in SSx cnd SFOPEN alls
c Aug 23 1985	Don't print any error messages if IDEV is -2 or less.

c Jan 22 1988	Replace PADSTR call with PADNULL

c Oct  5 1990	Fix bug concerning write-protected files

c Jul 11 1991	Eliminate unnecessary Return

c Feb 22 1993	Declare undeclared variables i and lfn
c Jun 10 1993	Allow writing into executable files
