/*** File israw.c
 *** November 16, 2001
 *** By Doug Mink
 */

/* ISRAW -- Fortran-callable program to set terminal to non-raw, echoing mode
            if terminal is not already set */
/* ISRAW -- A fortran-callable function that sets "ison" to 1 if
   linefeed character will NOT be transformed to carriage-return +
   linefeed on output.  This is not really what the function name
   implies, but is how it is used in skymap.
 */

#define TERMIOS
#ifdef TERMIOS
#include <termios.h>
#include <unistd.h>
#else
#include <sgtty.h>
#endif

israw_ (ison)

int	*ison;

#ifdef TERMIOS
{
  struct termios tios;
  int retval;

  if( (retval = tcgetattr(STDIN_FILENO, &tios)) < 0)
    return retval;
  *ison = ((tios.c_oflag & ONLCR) == 0);
  return 0;
}
#else
{
struct sgttyb arg;
int fildes,ier;
	fildes = 0;
	ier = ioctl (fildes,TIOCGETP,&arg);
	if (arg.sg_flags & RAW)
	   *ison = 1;
	else
	   *ison = 0;
	return;
}
#endif

/* Jul 27 1992	New subroutine
 *
 * Nov 13 2001	Modified by Chip Coldwell to use TERMIO library
 * Nov 16 2001	Set TERMIOS here
 */
