c*** File iolib/mean.f
c*** February 27, 1998
c*** By Doug Mink

	Subroutine MEANR4 (X, N, MEAN, SIGMA)

	Integer*4 N
c			Size of vector
	Real*4 X(N)
c			Vector of numbers of which median is to be found
	Real*4 MEAN
c			Median (returned)
	Real*4 SIGMA
c			Standard deviation (returned)

	Integer*4 I
	Real*8 SUM, SUMSQ, DIFF

c  If no points, return zero
	If (N .le. 0) Then
	    MEAN = 0.d0
	    SIGMA = 0.d0

c  If one point, reeturn zero standard deviation
	Elseif (N .eq. 1) Then
	    MEAN = X(1)
	    SIGMA = 0.d0

c  Compute mean and standard deviation of distribution
	Else
	    SUM = 0.d0
	    SUMSQ = 0.d0
	    Do I = 1, N
		SUM = SUM + X(I)
		Enddo
	    MEAN = SUM / Dble (N)
	    Do I = 1, N
		DIFF = Dble (X(I)) - MEAN
		SUMSQ = SUMSQ + (DIFF * DIFF)
		Enddo
	    SIGMA = Dsqrt (SUMSQ / Dble (N - 1))
	Endif

	Return
	End


	Subroutine MEANR8 (X, N, MEAN, SIGMA)

	Integer*4 N
c			Size of vector
	Real*8 X(N)
c			Vector of numbers of which median is to be found
	Real*8 MEAN
c			Mean (returned)
	Real*8 SIGMA
c			Standard deviation (returned)

	Integer*4 I
	Real*8 SUM, SUMSQ, DIFF

c  If no points, return zero
	If (N .le. 0) Then
	    MEAN = 0.d0
	    SIGMA = 0.d0

c  If one point, reeturn zero standard deviation
	Elseif (N .eq. 1) Then
	    MEAN = X(1)
	    SIGMA = 0.d0

c  Compute mean and standard deviation of distribution
	Else
	    SUM = 0.d0
	    SUMSQ = 0.d0
	    Do I = 1, N
		SUM = SUM + X(I)
		SUMSQ = SUMSQ + (X(I) * X(I))
		Enddo
	    MEAN = SUM / Dble (N)
	    Do I = 1, N
		DIFF = Dble (X(I)) - MEAN
		SUMSQ = SUMSQ + (DIFF * DIFF)
		Enddo
	    SIGMA = Dsqrt (SUMSQ / Dble (N - 1))
	Endif

	Return
	End


	Subroutine MEANI4 (X, N, MEAN, SIGMA)

	Integer*4 N
c			Size of vector
	Integer*4 X(N)
c			Vector of numbers of which median is to be found
	Integer *4 MEAN
c			Mean (returned)
	Integer*4 SIGMA
c			Standard deviation (returned)

	Integer*8 SUM, SUMSQ, DIFF
	Integer*4 I

c  If no points, return zero
	If (N .le. 0) Then
	    MEAN = 0.d0
	    SIGMA = 0.d0

c  If one point, reeturn zero standard deviation
	Elseif (N .eq. 1) Then
	    MEAN = X(1)
	    SIGMA = 0.d0

c  Compute mean and standard deviation of distribution
	Else
	    SUM = 0.d0
	    SUMSQ = 0.d0
	    Do I = 1, N
		SUM = SUM + X(I)
		Enddo
	    MEAN = SUM / Dble (N)
	    Do I = 1, N
		DIFF = Dble (X(I)) - MEAN
		SUMSQ = SUMSQ + (DIFF * DIFF)
		Enddo
	    SIGMA = Dsqrt (SUMSQ / Dble (N - 1))
	Endif

	Return
	End

c Feb 27 1998	New subroutines
