
/* Copyright(c) 1986 Association of Universities for Research in Astronomy Inc.
 */

#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
int lastsig;


/* ZOSCMD -- Send a (machine dependent) command to the host operating
 * system.  If nonnull stdout or stderr filenames are given, try to spool
 * the output in these files.
 */
shell_ (oscmd)
char	*oscmd;
{
	char	*shell, *sh = "/bin/sh";
	char	*sin, *sout, *serr, *cmd;
	char	*getenv();
	int	fd, pid, old_sigint;
	int	pr_onint();

	cmd  = (char *)oscmd;

	/* The Bourne shell SH is used if the first character of the cmd
	 * is '!' or if the user does not have SHELL defined in their
	 * environment.
	 */
	if ((shell = getenv ("SHELL")) == NULL)
	    shell = sh;

	old_sigint = (int) signal (SIGINT, SIG_IGN);

	/* Vfork is faster if we can use it.
	 */
	while ((pid = vfork()) != 0)
	    sleep (2);

	if (pid == 0) {
	    /* Child.
	     */

	    /* Run the system call.  Let child inherit the parents standard
	     * input unless redirected by nonnull stdin_file.  Set standard
	     * output and error output streams if filenames given, else write
	     * to same files (i.e., terminal) as parent.
	     */

	    /* Arrange for the local file descriptors of the parent to be closed
	     * in the child if the exec succeeds.  If this is not done the child
	     * may run out of file descriptors.
	     */

	    /* Spawn a shell to execute the command.
	     */
	    signal (SIGINT, old_sigint);
	    execl (shell, shell, "-c", cmd, 0);

	    /* NOTREACHED (unless execl fails) */
	    _exit (1);
	}

	/* Parent: wait for child to finish up.  Parent process should ignore
	 * interrupts; OS process will handle interrupts and return at the
	 * proper time.  The parent is out of the picture while the OS process
	 * is running (except for the pr_onint interrupt handler, below).
	 */
/*	pr_enter (pid, 0, 0); */
	lastsig = 0;
	if (old_sigint != (int) SIG_IGN)
	    signal (SIGINT, pr_onint);

	signal (SIGINT, old_sigint);
}


/* PR_ONINT -- Special interrupt handler for ZOSCMD.  If the OS command is
 * interrupted, post a flag to indicate this to ZOSCMD when the pr_wait()
 * returns.
 */
pr_onint (usig, hwcode, scp)
int	usig;				/* SIGINT, SIGFPE, etc.		*/
int	hwcode;				/* VAX hardware trap/fault codes */
struct	sigcontext *scp;
{
	lastsig = usig;
	/* return to wait() */
}
