c*** File iolib/nrange.f
c*** November 24, 1998
c*** By Doug Mink

c  RINIT (STRING, NVAL, IVAL) initializes string of ranges, returns number
c  RNEXT (STRING, IVAL, IER) returns next value from a string of ranges
c  NRANGE (STRING) return next range from string

c  RINIT--  Initialize string of ranges for subsequent use of RNEXT

	Subroutine RINIT (STRING, NVAL, IVAL)

	Character*(*) STRING	
c			Range string to be decoded
	Integer*4 NVAL
c			Number of values in range (returned)
	Integer*4 IVAL
c			Initialized range value (returned)

	Integer*4 I

	Include 'range.cmb'

c  Create token list from string

	NTMAX = 100
	Call SETOKEN (STRING,NTMAX,'-',NTOK,TOK0,TOK1)

c  Find number of values in range string

	NVAL = 0
	ITOK = 0
	Do I = 1, 100
	    Call NRANGE (STRING)
	    If (ITOK .lt. 0) Go to 100
	    NVAL = NVAL + VAL2 - VAL1 + 1
	    Enddo

100	Continue
	ITOK = 0
	Call NRANGE (STRING)
	IVAL = VAL1 - 1
	Return
	End


c  RNEXT--  Return next value from string of ranges

	Subroutine RNEXT (STRING, IVAL, IER)

	Character*(*) STRING	
c			Range string to be decoded
	Integer*4 IVAL
c			Initialized range value (returned)
	Integer*4 IER
c			Error if not zero (returned)

	Include 'range.cmb'

	IVAL = IVAL + 1
	If (IVAL .gt. VAL2) Then
	    Call NRANGE (STRING)
	    If (ITOK .lt. 0) Then
		IER = 1
	    Else
		IVAL = VAL1
	    Endif
	    Endif
	Return
	End


c--- Parse a string containing a list of integer numbers or ranges,
c    delimited by either spaces or commas.  Return as output a first
c    and last number, and an updated pointer to the string.  Range limits
c    must be integers.  The list of ranges is delimited by a single NULL.

	Subroutine NRANGE (STRING)

	Character*(*) STRING	
c			Range string to be decoded

	Integer*4 VAL,NC,I1,I2,IER

	Include 'range.cmb'

	VAL1 = -999999
	VAL2 = -999999

100	ITOK = ITOK + 1
	If (ITOK .gt. NTOK) Then
	    ITOK = -1
	    Return
	    Endif

	I1 = TOK0(ITOK)
	I2 = TOK1(ITOK)

c  Handle - and return first and last values of range

	If (STRING(I1:I2) .eq. '-') Then
	    ITOK = ITOK + 1
	    I1 = TOK0(ITOK)
	    I2 = TOK1(ITOK)
	    NC = I2 - I1 + 1
	    Call ASCBINI4 (NC,STRING(I1:I2),VAL,IER)
	    If (IER .eq. 0) Then
		VAL2 = VAL
	    Else
		Write(*,*) '*** DRANGE:  Illegal value = ',STRING(I1:I2)
	    Endif
	    Return

c  If individual number and value is already set, return

	Elseif (VAL1 .gt. -999999) Then
	    ITOK = ITOK - 1
	    Return

c  Handle individual number (may be start of range)

	Else
	    NC = I2 - I1 + 1
	    Call ASCBINI4 (NC,STRING(I1:I2),VAL,IER)
	    If (IER .eq. 0) Then
		VAL1 = VAL
		VAL2 = VAL
	    Else
		Write(*,*) '*** DRANGE:  Illegal value = ',STRING(I1:I2)
	    Endif
	Endif

	If (ITOK .lt. NTOK) Go to 100
	Return

	End
c Feb  5 1995	New fiel

c Nov 24 1998	Fix 2nd call to nrange()
