c*** File iolib/openwf.f
c*** February 22, 1993
c*** By Dick French and Doug Mink

	Subroutine OPENWF (IDEV, FNAME)

c--- Open Fortran 77 file for writing

	Integer*4 IDEV
c			Fortran 77 unit number
	Character*(*) FNAME
c			Null-terminated file pathname
c			If an error condition arises, this subroutine
c			will request a new file name from the user.

	Character FNAME0*64
	Integer*4 IER,IER1,IER2,I,IOS,LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for write permission and see if it's an executable 
c  file.  If write-protected, print error message and prompt user for new
c  file name and try again.

	If (IER .eq. 0) then
	   Call SSWRIT (FNAME,IER1)
	   Call ESET
	   If (IER1 .eq. -1) Write(*,15) FNAME
15	   Format('OPENWF: File "',A,'" is write-protected')
	   Call SSEXEC (FNAME,IER2)
	   If (IER2 .eq. 0) Write(*,16) FNAME
16	   Format('OPENWF: File "',A,'" is executable')
	   If ((IER1 .eq. -1) .or. (IER2 .eq. 0)) Then
	      Go to 100
	   Else
	      Open (IDEV,File=FNAME,Err=20,Iostat=IOS,Status='UNKNOWN')
	      Return

20	      Call ESET
	      Write(*,25) FNAME
25	      Format('OPENWF: File "',A,'" cannot be opened')
	      Write(*,*) '        Error code =',IOS
	      Go to 100
	   Endif

c  If file does not exist, create it.

	Else
	   Open (IDEV,File=FNAME,Status='NEW',Err=30,Iostat=IOS)
	   Return

30	   Call ESET
	   Write(*,35) FNAME
35	   Format('OPENWF: File "',A,'" not found; not creatable')
	   Write(*,*) '        Error code =',IOS
	   Go to 100
	Endif

c  Enter new file name

100	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Dec 28 1984	Change IDEV0 to IDEV in OPEN calls

c Jun 21 1985	Use Character filenames in SSx calls

c Jan 22 1988	Replace PADSTR call with PADNULL

c Oct  5 1990	Fix error in write-protect check

c Jul 11 1991	Set Open STATUS='UNKNOWN' and eliminate unnecessary Return

c Feb 22 1993	Declare undeclared variables i, ios, and lfn
