c*** File iolib/pput.f
c*** December 11, 2001
c*** By Doug Mink

	Subroutine PPUT (HSTRING,VNAME,ITYPE,IVAL)

c  Implant value for parameter VNAME into parameter string
c  HSTRING, taking it from address IVAL.

c	PPUT	(HSTRING,VNAME,ITYPE,IVAL) sets any type
c	PPUTI2	(HSTRING,VNAME,IVAL) sets Integer*2 IVAL
c	PPUTI4	(HSTRING,VNAME,IVAL) sets Integer*4 IVAL
c	PPUTR4	(HSTRING,VNAME,RVAL) sets Real*4 RVAL
c	PPUTR8	(HSTRING,VNAME,DVAL) sets Real*8 DVAL
c	PPUTNR8	(HSTRING,VNAME,DVAL) sets Real*8 DVAL, N decimal places
c	PPUTL	(HSTRING,VNAME,LVAL) sets Logical LVAL
c	PPUTS	(HSTRING,VNAME,CVAL) sets Character string CVAL adding ''
c	PPUTC	(HSTRING,VNAME,CVAL) sets Character string CVAL

	Character*(*) HSTRING
c		Character string containing information
c		in the format <VNAME>= <value> {/ <comment>}
c		Lines are of arbitrary length and are terminated by linefeeds.

	Character*(*) VNAME
c		Character string containing the name of the parameter
c		to be returned.  PPUT searches for a line beginning
c		with this string.
c		(THE FIRST 8 CHARACTERS OF A VARIABLE NAME MUST BE UNIQUE)

	Integer*4 ITYPE
c		Data type
c		  first ':' treated as '.', later ':'s and '.'s ignored.
c		  illegal characters, overflows, and underflows trapped. 
c		-1n: Integer n bytes long (Integer*n)
c		-2n: Floating point number n bytes long (Real*n)
c		-3n: Logical parameter n bytes long (Logical*n) (t or f)
c		-4n: Logical parameter n bytes long (Logical*n) (y or n)
c		1-99: Length of Character string returned, padded with spaces
c		101-199: Length (+100) of Character string returned
c		        padded with nulls
c		201-236: number (+200) of single characters
c			returned in array of 36 (A-Z,0-9) Integer*2
c			with array positions corresponding to letter
c			or number entered set to one.  Array is not
c			zeroed on entry.
c			Lower case letters are treated as upper case.
c		301-399: Length (+300) of Character string returned
c		        padded with nulls
c			Lower case letters are converted to upper case.

c	(Integer,Real) IVAL
c		Address for number, character, array, or string
c		If a Character string is to be set, call with
c		Equivalence'd Integer or use PPUTC; otherwise, Fortran adds
c		another invisible string length to the calling parameter list
c		and messes up everything.

	Character*30 VALUE
c		Character string containing value from parameter string

	Integer*2 IVAL(*)
	Integer*4 LVAL,IER

c  Translate value from binary to ASCII

	Call BINASC (LVAL,VALUE,ITYPE,IVAL,IER)

c  Put value and comment into parameter string

	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program

	Return
	End


c  Implant Integer*4 value IVAL for parameter VNAME into parameter string HSTRING

	Subroutine PPUTI4 (HSTRING,VNAME,IVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Integer*4 IVAL
c		Address for number

	Character*30 VALUE

c  Translate value from binary to ASCII

	Call BINASCI4 (IVAL,VALUE)

c  Put value and comment into parameter string

	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program

	Return
	End


c  Implant Integer*2 value IVAL for parameter VNAME into parameter string HSTRING

	Subroutine PPUTI2 (HSTRING,VNAME,IVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Integer*2 IVAL
c		Address for number

	Character*30 VALUE

c  Translate value from binary to ASCII
	Call BINASCI2 (IVAL,VALUE)

c  Put value and comment into parameter string
	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program
	Return
	End


c  Implant Real*4 value RVAL for parameter VNAME into parameter string HSTRING

	Subroutine PPUTR4 (HSTRING,VNAME,RVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Real*4 RVAL
c		Address for number

	Character*30 VALUE

c  Translate value from binary to ASCII
	Call BINASCR4 (RVAL,VALUE)

c  Put value and comment into parameter string
	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program
	Return
	End


c  Implant Real*8 value DVAL for parameter VNAME into parameter string HSTRING

	Subroutine PPUTR8 (HSTRING,VNAME,DVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Real*8 DVAL
c		Address for number

	Character*30 VALUE

c  Translate value from binary to ASCII
	Call BINASCR8 (DVAL,VALUE)

c  Put value and comment into parameter string
	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program
	Return
	End


c  Implant Real*8 value DVAL for parameter VNAME into parameter string HSTRING
c  Round to NDEC decimal places

	Subroutine PPUTNR8 (HSTRING,VNAME,DVAL, NDEC)

	Character*(*) HSTRING
	Character*(*) VNAME
	Real*8 DVAL
c		Address for number
	Integer*4 NDEC
c			Number of decimal places to save

	Character*30 VALUE

c  Translate value from binary to ASCII
	Call BINASCR8 (DVAL,VALUE)

c  Round to directed number of decimal places
	Call RNDASC (VALUE, NDEC)

c  Put value and comment into parameter string
	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program
	Return
	End


c  Implant Logical value DLAL for parameter VNAME into parameter string HSTRING

	Subroutine PPUTL (HSTRING,VNAME,IVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Logical IVAL
c		Address for number

	Character*5 VALUE

c  Translate value from binary to ASCII

	If (IVAL) Then
	    VALUE = 'T'
	Else
	    VALUE = 'F'
	Endif
	Call PADNULL (VALUE)

c  Put value and comment into parameter string

	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program

	Return
	End


c  Implant Character string value for parameter VNAME into parameter string
c  HSTRING, preserving case and adding single quotes around it

	Subroutine PPUTS (HSTRING,VNAME,CVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Character*(*) CVAL
c			Character string containing the value for parameter
c			VNAME.  Trailing and leading blanks are removed.

	Character*4 JQUOT,NULL
	Character*100 VALUE
	Integer*4 LCVAL

	Include 'header.cmb'

	JQUOT(1:1) = Char (39)
	NULL(1:1) = Char (0)

c  Find length of variable string

	Call VLEN (CVAL,LCVAL)
	Call ZSTRING (VALUE)

c  Put quotes around string

	VALUE(1:1) = JQUOT
	VALUE(2:LCVAL+1) = CVAL(1:LCVAL)
	VALUE(LCVAL+2:LCVAL+2) = JQUOT
	VALUE(LCVAL+3:LCVAL+3) = NULL(1:1)

c  Put value and comment into header string

	Call PPUTC (HSTRING,VNAME,VALUE)

c  Return to calling program

	Return
	End


c  Implant Character string value for parameter VNAME into parameter string HSTRING

	Subroutine PPUTC (HSTRING,VNAME,CVAL)

	Character*(*) HSTRING
	Character*(*) VNAME
	Character*(*) CVAL
c			Character string containing the value for parameter
c			VNAME.  Trailing and leading blanks are removed.

	Character*1 JLF,JQUOT1,JQUOT2
	Character*140 LINE
	Integer*4 LVNAME,LVAL,LV0,LV1,LV,LH0,LH1,LC0,LQ0,LQ1,LT0,L0,L1,LLIN
	Integer*4 NVAL,NEND,LHEAD,LEND,LCVAL,I,LDIF

	Include 'header.cmb'

	JLF = Char (10)
	JQUOT1 = Char (39)
	JQUOT2 = Char (34)
	FOUND = .false.

c  Find length of parameter name

	Call VLEN (VNAME,LVNAME)

c  Find length of parameter value

	LCVAL = Len (CVAL)
	If (LCVAL .ne. 1) Call VLEN (CVAL,LCVAL)
	If (LCVAL .le. 0) Return

c  Find END of parameter string

	Call VLEN (HSTRING,LHEAD)
	Call PSEARCH (HSTRING,'END',LEND,NEND)
	LH1 = LEND + 3
c	If (VERBOSE) Write(*,*) 'END at',LEND,'/',LHEAD

c  Search parameter string for parameter name

	Call PSEARCH (HSTRING,VNAME,L0,NVAL)
	If (L0 .gt. 0) FOUND = .true.

c  If parameter is not found, insert it before END

	If (.not. FOUND) Then
	    L0 = LEND
	    L1 = L0 + LVNAME - 1
	    HSTRING(L0:L1) = VNAME(1:LVNAME)
	    L1 = L1 + 1
	    HSTRING(L1:L1) = '='
	    HSTRING(L1+1:L1+LCVAL) = CVAL(1:LCVAL)
	    L1 = L1 + LCVAL + 1
	    HSTRING(L1:L1) = JLF
	    HSTRING(L1+1:L1+3) = 'END'
	    HSTRING(L1+4:L1+4) = JLF

c  Find end of current parameter entry.

	Else
	    L1 = L0 + NVAL - 1
c	    If (VERBOSE) Write(*,*) L0,L1,HSTRING(L0:L1)

c  Extract entry for this parameter from the parameter string

	    Call ZFILLC (LINE,Len(LINE))
	    LINE(1:NVAL) = HSTRING(L0:L1)
	    LLIN = L1 - L0 + 1

c  Check for quoted value

	    LQ0 = Index (LINE,JQUOT1)
	    If (LQ0 .gt. 0) Then
		LQ1 = Index (LINE(LQ0+1:NVAL),JQUOT1) + LQ0
	    Else
		LQ0 = Index (LINE,JQUOT2)
		If (LQ0 .gt. 0) Then
		    LQ1 = Index (LINE(LQ0+1:NVAL),JQUOT2) + LQ0
		Else
		    LQ1 = 0
		Endif
	    Endif
c	    If (VERBOSE) Write(*,*) 'Quotes:',LQ0,LQ1

c  Check for tabs after parameter value

	    LT0 = Index (LINE(LQ1+1:),Char(9))
	    If (LT0 .gt. 0) LT0 = LT0 + LQ1

c  Find start of comment field

	    If (LT0 .gt. 0) Then
		LC0 = Index (LINE(LT0+1:),'/')
		If (LC0 .gt. 1) LC0 = LC0 + LT0
	    Else
		LC0 = Index (LINE(LQ1+1:),'/')
		If (LC0 .gt. 1) LC0 = LC0 + LQ1
	    Endif

c  Find limits of current value

	    If (LQ0 .gt. 0) Then
		LV0 = LQ0
		LV1 = LQ1
	    Else
		LV0 = Index (LINE,'=') + 1
		LV1 = LT0 - 1
		If (LV1 .lt. 0) LV1 = LC0 - 1
		If (LV1 .lt. 0) LV1 = LLIN
	    Endif

c  Ignore leading or trailing spaces if not quoted

	    If (LQ0 .le. 0) Then
		Do 100 LV = LV0, LV1
100		    If (LINE(LV:LV) .ne. ' ') Go to 110
110		LV0 = LV
		Do 120 LV = LV1, LV0, -1
120		    If (LINE(LV:LV) .ne. ' ') Go to 130
130		LV1 = LV
		Endif
	    LVAL = LV1 - LV0 + 1

c  Convert to postion in parameter string
  
	    LV0 = LV0 + L0 - 1
	    LV1 = LV1 + L0 - 1

c  Shift current parameter string to make space for new value

	    LDIF = LCVAL - LVAL
	    LH1 = LH1 + LDIF
	    LH0 = LV0 + LCVAL
	    If (LDIF .gt. 0) Then
		Do 134 I = LH1, LH0, -1
134		    HSTRING(I:I) = HSTRING(I-LDIF:I-LDIF)
	    Elseif (LDIF .lt. 0) Then
		Do 135 I = LH0, LH1, 1
135		    HSTRING(I:I) = HSTRING(I-LDIF:I-LDIF)
	    Endif

c  Insert new entry into parameter string

	    HSTRING(LV0:LV0+LCVAL-1) = CVAL(1:LCVAL)
	Endif

	If (VERBOSE) Then
c	    Write(*,*) 'Name:',LVNAME,'Value:',LV0,'-',LV1,'->',LV0+LCVAL-1,LVAL,
c     1	    '->',LCVAL
	    Write(LINE,140) VNAME(1:LVNAME),CVAL(1:LCVAL)
140	    Format('Setting ',A,' = ',A,'$')
	    Call PSTRING (LINE)
	    Endif

	Return
	End

c Jul 28 1987	Add PPUTS which put quotes around strings automatically
c Nov  2 1987	Write VERBOSE diagnostics using PSTRING

c May  2 1988	Increase LINE to 140 to avoid overflow

c Sep 28 1990	Use type-specific calls to BINASC; Drop PPUTCOM

c Oct 28 1992	Increase maximum string size in PPUTS to 100
c		Declare undeclared variables

c Feb 22 1993	Use jquot in pputc

c Jun 28 1999	Add PPUTNR8() to write a specific number of decimal places

c Dec 11 2001	In PPUTC(), initialize all of LINE, not just 100 characters
