c*** File iolib/psearch.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine PSEARCH (HSTRING,VNAME,PVAL,NVAL)

c*** Find entry for keyword VNAME in FITS-like header string HSTRING.
c    The position of the start of its value in ASCII and the number of
c    characters in the ASCII value are returned.

c---search for keyword (assumed to be BLANK-PADDED, NOT NULL-PADDED!)
c   (ASSUMPTION : THE FIRST 8 CHARACTERS OF A KEYWORD ARE UNIQUE)

	Character*(*) HSTRING
c			Character string containing FITS-style header information
c			in the format <VNAME>= <value> {/ <comment>}
c			The default is that each entry is 80 characters long;
c			however, lines may be of arbitrary length terminated by
c			nulls, carriage returns or linefeeds, if PACKED is .true..
	Character*(*) VNAME
c			Character string containing the name of the variable
c			to be returned.  PSEARCH searches for a line beginning
c			with this string.
c			IMPORTANT:  This string MUST be terminated by a NULL or
c		            by a '$' and is truncated to 10 characters.
	Integer*4 PVAL
c			Fortran index of position in HSTRING at which entry for
c			variable VNAME starts.
c			If VNAME is not found, a value of 0 is returned.
	Integer*4 NVAL
c			Number of characters in entry
c			If VNAME is not found, a value of 0 is returned.

	Character*1 HS1,JLF,JCR
c	Character LINE*100
	Integer*4 LVNAME,NEXTCHAR,HLEN,L0,LOC,ISTART

	Include 'header.cmb'

	JCR = Char (13)
	JLF = Char (10)
	NVAL = 0
	PVAL = 0

c  Find length of variable name

	Call VLEN (VNAME,LVNAME)
	If (LVNAME .lt. 1) Return

c  Search header string for variable name

	HLEN = Len (HSTRING)
	L0 = 0
30	ISTART = L0 + 1
	If (ISTART .gt. HLEN) Then
	    Return
	    Endif
	LOC = Index (HSTRING(ISTART:),VNAME(1:LVNAME))

c  Exit if not found

	If (LOC .eq. 0) Then
	    Return
	    Endif

c  If parameter name in string entry is longer, keep searching

	L0 = LOC + ISTART - 1
	NEXTCHAR = Ichar (HSTRING(L0+LVNAME:L0+LVNAME))
	If ((NEXTCHAR.ne.61).and.(NEXTCHAR.gt.32).and.(NEXTCHAR.lt.127)) Then
	    ISTART = L0 + 1
	    Go to 30
	    Endif

c  See if this is a legal position for a keyword.  If not, assume it is in
c  the comment or value  field, and keep searching.

	HS1 = JLF
	If (L0 .gt. 1) HS1 = HSTRING(L0-1:L0-1)
	If ((HS1.ne.JCR) .and. (HS1.ne.JLF)) Then
	    ISTART = L0 + 1
	    Go to 30
	Else
	    NVAL = Index (HSTRING(L0:),JLF) - 1
	    PVAL = L0
	Endif

c  Return to calling program

	Return
	End

c Aug 12 1987	If length of parameter name is 0, return immediately
c Sep 21 1987	Fix bug which failed to compare all characters in string

c Oct  5 1990	Fix minor errors using flint

c Sep  3 1992	Declare undeclared variables

c Feb 22 1993	Substitute single quotes for double quotes
