c*** File iolib/rndasc.f
c*** April 24, 1996
c*** By Doug Mink

c--- RNDASC Round ASCII number to NDEC decimal places

	Subroutine RNDASC (STRING,NDEC)

	Character*(*) STRING
c		Character string (modified and returned)

	Integer*4 NDEC
c		Number of decimal places in number in string

	Character*1 CDOT
	Integer*4 I,IDOT,IER,IRND,J,LSTR,NZADD, FDOT
	Real*8 DVAL

	CDOT = '.'
	IDOT = Index (STRING,CDOT)

c  Do not round if in floating point format

	FDOT = Index (STRING,'E')
	If (FDOT .le. 0) FDOT = Index (STRING,'e')
	If (FDOT .le. 0) FDOT = Index (STRING,'D')
	If (FDOT .le. 0) FDOT = Index (STRING,'d')
	If (FDOT .gt. 0) Return

c  If integer and no decimal places are expected, return

	If (NDEC .eq. 0) Then
	    If (IDOT .eq. 0) Then
		Return

c  If decimal digits exist, round to integer

	    Else
		Call ASCBINI4 (IDOT-1,STRING,J,IER)
		I = Ichar (STRING(IDOT+1:IDOT+1))
		If (I .ge. 5) Then
		    If (J .ge. 0) Then
			J = J + 1
		    Else
			J = J - 1
		    Endif
		    Endif
		Call BINASCI4 (J,STRING)
		Return
	    Endif
	    Endif

c  If integer and decimal places are expected, add trailing zeroes

	If (IDOT .le. 0) Then
	    If (NDEC .gt. 0) Then
		Call CONSTR (STRING,'.$')
		Do 10 I = 1, NDEC
10		    Call CONSTR (STRING,'0$')
		Return
		Endif

c  If integer and roundoff is expected, set decimal point position to EOS

	    Call VLEN (STRING,IDOT)
	    IDOT = IDOT

c  If floating point, add trailing zeroes if necessary

	Elseif (NDEC .gt. 0) Then
	    Call VLEN (STRING,LSTR)
	    NZADD = NDEC - (LSTR - IDOT)
	    If (NZADD .gt. 0) Then
		Do 20 I = 1, NZADD
20		    Call CONSTR (STRING,'0$')

c  If floating point, round decimal places

	    Else
		Call ASCBINR8 (IDOT+NDEC+1,STRING,DVAL,IER)
		IRND = IDOT + NDEC + 1
		I = Ichar (STRING(IRND:IRND)) - 48
		If (I .ge. 5) Then
		    If (DVAL .ge. 0) Then
			DVAL = DVAL + (10.d0**(-NDEC))
		    Else
			DVAL = DVAL - (10.d0**(-NDEC))
		    Endif
		    Endif
		Call BINASCR8 (DVAL,STRING)
		IDOT = Index (STRING,CDOT)
		IRND = IDOT + NDEC
		Call VLEN (STRING,LSTR)
		If (LSTR .gt. IRND) Then
		    Do 30 I = IRND+1, LSTR
30			STRING(I:I) = Char (0)
		Elseif (LSTR .lt. IRND) Then
		    Do 40 I = LSTR+1, IRND
40			Call CONSTR (STRING,'0$')
		Endif
	    Endif
	Endif

	Return
	End

c Feb 22 1993	Declare undeclared variables i, idot,ier,irnd,j,lstr,ndec0
c Nov 11 1993	Fix rounding when adding zeroes

c Oct 11 1995	Do not round numbers in floating point format
c Apr 24 1996	Fix rounding of decimal places
