/*** File rset.c
 *** March 24, 2008
 *** By Doug Mink
 */

/* RSET -- Fortran-callable program to set terminal to raw, non-echoing mode
     if terminal is not already set
 */

#include <termios.h>
#include <unistd.h>

rset_ ()

{
  struct termios tios;
  int retval;
  void xfmakeraw();

  if( (retval = tcgetattr(STDIN_FILENO, &tios)) < 0)
    return retval;
  xfmakeraw(&tios);
  return tcsetattr(STDIN_FILENO, TCSAFLUSH, &tios);
}

/* Solaris does not have the cfmakeraw function which Linux does */

void
xfmakeraw (struct termios *tios)

{
    tios->c_iflag &= ~(IGNBRK|BRKINT|PARMRK|ISTRIP
			    |INLCR|IGNCR|ICRNL|IXON);

    tios->c_oflag &= ~OPOST;

    tios->c_lflag &= ~(ECHO|ECHONL|ICANON|ISIG|IEXTEN);
    tios->c_cflag &= ~(CSIZE|PARENB);
    tios->c_cflag |= CS8;
}

/* Jun  4 1984	New subroutine
 *
 * Nov 13 2001	Modified by Chip Coldwell to use TERMIO library
 * Nov 16 2001	Set TERMIOS here
 *
 * Mar 24 2008	Drop non-TERMIOS code entirely; add xfmakeraw()
 */
