/*** File iolib/schgrp.c
 *** September 10, 1990
 *** By Doug Mink
 */

#include <grp.h>

schgrp_ (path,group,ier,nc1,nc2)

/*   Change group ownership of UNIX file (Fortran-callable)
 *
 *	Call SCHGRP (PATH,GROUP,IER) from Fortran
 *
 *	Character*(*) PATH
 *			Address of null-terminated file name (=path name)
 *	Character*(*) GROUP
 *			Address of null-terminated group name
 *	Integer*4 IER
 *			Address of error number (0=success)
 *
 *	nc1	Number of characters in string PATH
 *	nc2	Number of characters in string GROUP
 *		* these are not explicitly in the calling argument list;
 *		* Fortran puts them there
 */

char *path;
char *group;
int *ier;
int nc1,nc2;

{
int err,sameown,newgrp;
struct group *grp;
extern int errno;

/* Set new owner to unchanged */

	sameown = -1;
	
	grp = getgrnam (group);
	newgrp = grp->gr_gid;

/* Open file */

	err = chown (path,sameown,newgrp);

/* Set returned file descriptor */

	if (err == 0) *ier = 0;
	else *ier = errno;
	
	return;
}
