/*** File iolib/schmod.c
 *** March 24, 2008
 *** By Doug Mink
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

void
schmod_ (path,mode,ier,nc)

/*   Change mode of UNIX file (Fortran-callable)
 *
 *	Call SCHMOD (PATH,MODE,IER) from Fortran
 *
 *	Character*(*) PATH
 *			Address of null-terminated file name (=path name)
 *	Integer*4 MODE
 *			Address of mode mask (000-777)
 *	Integer*4 IER
 *			Address of error number (0=success)
 *
 *	nc	Number of characters in string PATH
 *		* this is not explicitly in the calling argument list;
 *		* Fortran puts it there
 */

char *path;
int *mode;
int *ier;
int nc;

{
    int err, nmode;
    mode_t newmode;
    extern int errno;

    nmode = *mode;
    if (nmode < 0)
	newmode = 0;
    else
	newmode = nmode;

    /* Change file mode */
    err = chmod (path,newmode);

    /* Set returned file descriptor */
    if (err == 0) {
	*ier = 0;
	fprintf (stderr,"SCHMOD:  Mode changed to %d\n",newmode);
	}
    else {
	*ier = errno;
	fprintf (stderr,"SCHMOD:  Mode %d change failed, error = %d\n",newmode,ier);
	}
    return;
}
/* Apr 25 1991	New subroutine
 *
 * May 20 1998	Declare void
 *
 * Mar 24 2008	Include stdio.h and stdlib.h for fprintf()
 */
