/*** File iolib/sflip.c
 *** March 22, 1991
 *** By Doug Mink, Center for Astrophysics

 *** Reverse rows of a 2-D array (flip image up and down)
 */

#include <stdio.h>
#include <stdlib.h>

sflip_ (array,nrow,nbcol)

char *array;	/* Address of array to flip */
int *nrow;	/* Address of number of rows in image */
int *nbcol;	/* Address of number of bytes per row */

{
char *ra, *rb, *rmid, *rbi, *rai, *ral, *rbl, *tvi;
char *tvec;	/* Address of temporary line vector */
int nc, nr;

	nc = *nbcol;
	nr = *nrow;
	if ((tvec = malloc (nc)) == NULL) {
            fprintf (stderr,"Can't malloc %d bytes for temp vector\n",nc);
            exit (1);
	    }

	ra = array;
	rb = array + ((nr - 1) * nc);
	rmid = array + ((nr / 2) * nc);

	while (ra <= rmid) {
	    tvi = tvec;
	    ral = ra + nc;
	    for (rai = ra; rai < ral; rai++) *tvi++ = *rai;
	    rbi = rb;
	    for (rai = ra; rai < ral; rai++) *rai = *rbi++;
	    tvi = tvec;
	    rbl = rb + nc;
	    for (rbi = rb; rbi < rbl; rbi++) *rbi = *tvi++;
	    ra = ra + nc;
	    rb = rb - nc;
	    }

	return;
}
