/*** File iolib/sgchrs.c
 *** November 16, 2001
 *** By Doug Mink
 */

void
sgchrs_ (itype,buf,nchar,lchar,nc)

/*   Read terminal entry (Fortran-callable)
 *
 *	itype	Address of entry type
 *
 *	buf	Address of buffer array (values returned)
 *
 *	nchar	Address of number of characters read (value returned)
 *
 *	lchar	Address of last character read (value returned)
 */
char *buf;
int *lchar;
int *nchar,*itype,nc;
{
int iret,ichr,itp,mch,nch,nb,nr,nw,fdin,fdout,ich;
int iesc;	/* Set to 1 on encountering an escape character */
int lbrack;	/* Set to one on encountering a left bracket */
int insert;
char jchr,jc[3];

	itp = *itype;
	if (itp > 300) mch = itp - 300;
	else if (itp > 200) mch = itp - 200;
	else if (itp > 100) mch = itp - 100;
	else if (itp > 0) mch = itp;
	else if (itp == -1 || itp < -30) mch = 1;
	else mch = 99;

	nch = *nchar;
	ich = nch;
	iret = 0;
	nb = 1;
	rset_();
	fdin = 0;
	fdout = 1;
	iesc = 0;
	lbrack = 0;

	while (!iret) {

	    while (read (fdin,&jchr,nb) == 0);

	    ichr = jchr;
	    if (ichr > 128) ichr = ichr + 128;
	    if ((itp > 300 || itp == -1 || itp < -30) & (ichr > 96 & ichr < 123))
		ichr = ichr - 32;

	    switch (ichr) {

	    case 3:	iret = 1;	/* ^C aborts entry */

	    case 27:	if (iesc) {	/* 2 <escape>'s abort entry */
			    iret = 1;
			    }
			iesc = 1;
			break;

	    case 10:	nch = 0;	/* linefeed echoes last entry */
			iret = 1;
			break;

	    case 13:	iret = 1;	/* carriage return terminates entry */
			break;

	    case 17:			/* ignore ^S and ^Q */
	    case 19:	break;

	    case 18:	iret = 1;	/* ^R plays back current entry */
			break;

	    case 8:			/* delete on backspace or rubout */
	    case 127:	buf[nch] = 0;
			nch = nch - 1;
			ich = nch;
			if (nch < 0) nch = 0;
			else {
			    jc[0] = 8;
			    jc[1] = 32;
			    jc[2] = 8;
			    nw = write (fdout,jc,3); }
			break;

	    case 67:	if (lbrack) {	/* esc[C moves cursor right */
			    if (nch > 0) {
				insert = 1;
				jc[1] = 32;
				nw = write (fdout,jc,3);
				}
			    lbrack = 0;
			    iesc = 0;
			    break;
			    }

	    case 68:	if (lbrack) {	/* esc[D moves cursor left */
			    if (nch > 0) {
				insert = 1;
			    	jc[0] = 8;
				jc[1] = 32;
				jc[2] = 8;
				nw = write (fdout,jc,3);
				}
			    lbrack = 0;
			    iesc = 0;
			    break;
			    }

	    case 91:	if (iesc) {	/* [ prefaces cursor movement */
			    lbrack = 1;
			    break;
			    }
	    default:			/* otherwise add character to entry */
			if (nch < 0) nch = 0;
			if (nch <= mch) {
			    jchr = ichr;
			    buf[nch] = jchr;
			    nch++;
			    ich = nch;
			    nw = write (fdout,&jchr,1);
			    if (mch == 1) iret = 1; }
	    }

	    }

	eset_();
	*lchar = ichr;
	*nchar = nch;
	return;
}
/* Sep 28 1990	Created
 *
 * Sep 11 1992	Fix mch for 0<itype<100
 *
 * Feb  6 1998	Declare insert, though unused for now
 * May 20 1998	Declare subroutine void

 * Mar 17 2000	Fix bugs found by DEC Fortran compiler
 *
 * Nov 16 2001	Fix logical or bugs found by Chip Coldwell
 */
