/*** File iolib/slsec.c
 *** December 30, 1999
 *** By Doug Mink
 */
#include <time.h>

void
slsec_ (sec)

/* Get the local time, in units of seconds since 1950-01-01T00:00.
 *
 *	sec	local seconds since 1950.0 (Real*8)
 */
double *sec;
{
    time_t ut0,utc;             /* UTC seconds since 1970-01-01T00:00 */
    struct tm *ltm;             /* Local time structure */
    int lt;                     /* Local time returned */

    /* Get current UTC */
    ut0 = (time_t) 0;
    utc = time (&ut0);

    /* Subtract minutes westward from UTC */
    ltm = localtime (&utc);
    *sec = utc - timezone;

    /* Correct for daylight savings time, if in effect */
    if (ltm->tm_isdst)
        *sec += 3600.0;

/* Correct from 1970-01-01T00:00 to 1950-01-01T00:00 */
    *sec += 631152000.0;

    return;
}
/* Sep 14 1993	New subroutine
 *
 * May 20 1998	Declare void
 *
 * Dec 30 1999	Fix for Solaris, using method from WCSTools imhfile.c
 */
