/*** File iolib/sopen.c
 *** March 30, 1986
 *** By Doug Mink
 */

#include <sys/file.h>

sopen_ (dev,flag,path,nc)

/*   Open UNIX file (Fortran-callable)
 *
 *	Call SOPEN (DEV,FLAG,PATH) from Fortran
 *
 *	Integer*4 DEV
 *			Address of UNIX file descriptor (returned)
 *	Integer*4 FLAG
 *			Address of read(=0)/write(=1)/create(=2)/update(=3) flag
 *	Character*(*) PATH
 *			Address of null-terminated file name (=path name)
 *
 *	nc	Number of characters in string PATH
 *		* this is not explicitly in the calling argument list;
 *		* Fortran puts it there, necessitating this variation on SPUT
 */

char *path;
int *flag;
int *dev;
int nc;

{
int idev,flags,mode;
extern int errno;

/* Set flags for various kinds of file opening */

	if (*flag == 0) flags = O_RDONLY;
	if (*flag == 1) flags = O_WRONLY;
	if (*flag == 2) flags = O_RDWR + O_CREAT;
	if (*flag == 3) flags = O_RDWR;

/* Set file open mode to write by user, read by everyone */

	mode = 0644;

/* Open file */

	idev = open (path,flags,mode);
/*	printf ("openf: device is %d, flag is %d \n",idev,flags); */

/* Set returned file descriptor */

	if (idev > 0) *dev = idev;
	else *dev = -errno;
	
	return;
}
