/*** File iolib/sswap.c
 *** May 20, 1998
 *** By Doug Mink
 */

#include <sys/file.h>

sswap2_ (string,nbytes)

/*   Swap bytes in string (Fortran-callable)
 *
 *	string	Address of string
 *
 *	nbytes	Address of number of bytes to swap
 */

char *string;
int *nbytes;

{
    int ier,nb;
    char *sbyte, temp, *slast;

    nb = *nbytes;
    slast = string + nb;
    sbyte = string;
    while (sbyte < slast) {
	temp = sbyte[0];
	sbyte[0] = sbyte[1];
	sbyte[1] = temp;
	sbyte= sbyte + 2;
	}
    return;
}


void
sswap4_ (string,nbytes)

/*   Reverse bytes of Integer*4 or Real*4 vector (Fortran-callable)
 *
 *	string	Address of Integer*4 or Real*4 vector
 *
 *	nbytes	Address of number of bytes to reverse
 */

char *string;
int *nbytes;

{
    char *sbyte, temp, *slast;
    char temp0, temp1, temp2, temp3;
    int nb;

    nb = *nbytes;
    slast = string + nb;
    sbyte = string;
    while (sbyte < slast) {
	temp3 = sbyte[0];
	temp2 = sbyte[1];
	temp1 = sbyte[2];
	temp0 = sbyte[3];
	sbyte[0] = temp0;
	sbyte[1] = temp1;
	sbyte[2] = temp2;
	sbyte[3] = temp3;
	sbyte = sbyte + 4; }

    return;
}


void
sswap8_ (string,nbytes)

/*   Reverse bytes of Real*8 vector (Fortran-callable)
 *
 *	string	Address of Integer*4 vector
 *
 *	nbytes	Address of number of bytes to reverse
 */

char *string;
int *nbytes;

{
    char *sbyte, *slast;
    char temp[8];
    int nb;

    nb = *nbytes;
    slast = string + nb;
    sbyte = string;
    while (sbyte < slast) {
	temp[7] = sbyte[0];
	temp[6] = sbyte[1];
	temp[5] = sbyte[2];
	temp[4] = sbyte[3];
	temp[3] = sbyte[4];
	temp[2] = sbyte[5];
	temp[1] = sbyte[6];
	temp[0] = sbyte[7];
	sbyte[0] = temp[0];
	sbyte[1] = temp[1];
	sbyte[2] = temp[2];
	sbyte[3] = temp[3];
	sbyte[4] = temp[4];
	sbyte[5] = temp[5];
	sbyte[6] = temp[6];
	sbyte[7] = temp[7];
	sbyte = sbyte + 8;
	}
    return;
}
/* Sep 14 1993	New program
 *
 * Mar 28 1995	Use same method in SSWAP2 as SSWAP4 and SSWAP8 
 *
 * May 20 1998	Declare subroutines void
 */
