/*** File stime.c
 *** February 18, 2005
 *** By Doug Mink
 */
#include <time.h>
#include <sys/time.h>

void
stime_ (sec,ndr)

/*   Return current local time and UT seconds since 1950.0 (Jan 0,1950, 12:00)
 *
 *	ndr[7]	Time array (Integer*2)
 *		Month, Day, Year, Hour, Minute, Seconds, Milliseconds
 *
 *	sec	UT seconds since 1950.0 (Integer*4, add ND(7) for exact time)
 */
short *ndr;
int *sec;
{
    int days,nc,nly,ny,nc4;
    time_t tsec;
    int i;
    short im,m,nmon;
    struct timeval tp;
    struct timezone tzp;
    short nd[7];
    struct tm *tstruct;

    gettimeofday (&tp,&tzp);

    tsec = tp.tv_sec;
    *sec = tsec + 63115200 + 43200;

    /* Milliseconds */
    nd[6] = tp.tv_usec / 1000;

    /* printf ("tsec = %d, usec = %d \n",tsec,tp.tv_usec); */

    tstruct = localtime (&tsec);

    /* Time of day (Hours, Minutes, Seconds)   */
    nd[3] = tstruct->tm_hour;
    nd[4] = tstruct->tm_min;
    nd[5] = tstruct->tm_sec;

    /* Day of month   */
    nd[1] = tstruct->tm_mday;

    /* Month   */
    nd[0] = tstruct->tm_mon + 1;

    /* Year   */
    nd[2] = tstruct->tm_year + 1900;

    /* printf ("%d%/%d%/%d  %d%:%d%:%d %d \n",nd[0],nd[1],nd[2],
            nd[3],nd[4],nd[5],nd[6]);   */

    for (i = 0; i < 7; i++ )
	*(ndr+i) = nd[i];
    return;
}
/* Apr 15 1992	Use localtime() to apply daylight savings time correction
 *
 * May 20 1998	Declare void
 *
 * Feb 18 2005	Make tsec time_t instead of long
 */
