/*** File iolib/vecnorm4.c
 *** June 15, 1988
 *** By Doug Mink, Center for Astrophysics
 */

vecnorm4_ (vec4,lvec,xmult,xadd)

/*   Multiply vector of 4-byte integers
 *
 *	vec4	Address of output Integer*4 vector
 *
 *	lvec	Address of number of elements in vector
 *
 *	xmult	Address of number by which to multiply vector
 *
 *	xadd	Address of number to add to vector
 */

int *vec4;
int *lvec;
double *xmult;
double *xadd;

{
int *v4, *veclast;
register double vr, xa, xm;

	v4 = vec4 - 1;
	veclast = v4 + *lvec;
	xm = *xmult;
	xa = *xadd;

	if (*xmult != 0.) {
	    while (v4++ < veclast) {
		vr = (double) *v4;
		vr = (vr * xm) + xa;
		if (vr >= 0) *v4 = (int) (vr + 0.5);
		if (vr < 0)  *v4 = (int) (vr - 0.5);
		/* printf ("%d * %d = %d \n",vr,xm,xa,*v4); */
		}
	    }
	
	return;
}
