c*** File iolib/vigsec.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine VIGSEC (V,S)

c   This subroutine converts a date and time to seconds past 0h 1/1/1950.
c   It replaces the JPL routine VIGSEC and uses Real*8 floating point
c   instead of 32-bit integers for date and time.

	Real*8 V(2)
c			V(1) is date as yyyy.mmdd
c			    yyyy = calendar year (e.g. 1973)
c			    mm = calendar month (e.g. 04 = april)
c			    dd = calendar day (e.g. 15)
c			V(2) is time as hh.mmssxxxx
c		       *if V(2)<0, it is time as -(fraction of a day)
c			    hh = hour of day (0 .le. hh .le. 23)
c			    nn = minutes (0 .le. nn .le. 59)
c			    ss = seconds (0 .le. ss .le. 59)
c			  xxxx = tenths of milliseconds (0 .le. xxxx .le. 9999)
	Real*8 S
c			 Seconds past 1950.0

	Real*8 DH,DM,DD
	Integer*4 ID, IM, IY

	If (V(1) .lt. 0.0301d0) Return

c  Calculate the number of full years, months, and days already
c  elapsed since 0h, March 1, -1 (up to most recent midnight).

c  Convert time of day to elapsed seconds

	S = V(2) * -8.64d4
	If (V(2) .gt. 0) Then
	    DH = Dint (V(2) + 1.0d-10)
	    DM = Dint (((V(2)-DH) * 1.0d2) + 1.0d-10)
	    S = (V(2) * 1.0d4) - (DH * 1.0d4) - (DM * 1.0d2)
	    S = Dint (S * 1.d5 + 1.d-4) / 1.d5
	    S = S + (DM * 60.0d0) + (DH * 3600.0d0)
	    Endif

c  Calculate the number of full months elapsed since
c  the current or most recent March

	IY = Idint (V(1) + 1.0d-10)
	IM = Idint (((V(1) - Dble (IY)) * 1.0d4) + 1.0d-8)
	ID = Mod (IM,100)
	IM = (IM / 100) + 9
	If (IM .lt. 12) IY = IY - 1
	IM = Mod (IM, 12)
	ID = ID - 1

c  Starting with March as month 0 and ending with the following
c  February as month 11, the calculation of the number of days
c  per month reduces to a simple formula. the following statement
c  determines the number of whole days elapsed since 3/1/-1 and then
c  subtracts the 712163 days between then and 1/1/1950.  it converts
c  the result to seconds and adds the accumulated seconds above.

	ID = ID + ((IM+1+IM/6+IM/11)/2 * 31) + ((IM-IM/6-IM/11)/2 * 30)
     2	+ (IY / 4) - (IY / 100) + (IY / 400)
	DD = Dble (ID) + (365.d0 * Dble (IY)) - 712163.d0
	S = S + (DD * 8.64d2)

	Return
	End

c Feb 22 1993	Declare undeclared variables id, im, and iy
