# File svdfit/lib/contin.h
# January 18, 2000

# Continuum fitting functions
define  CN_INTERP_MODE  "|spline3|legendre|chebyshev|spline1|"
define  CN_SPLINE3	      1
define  CN_LEGENDRE	     2
define  CN_CHEBYSHEV	    3
define  CN_SPLINE1	      4

# Continuum Subtraction Parameter Commands
define	CONT_KEYWORDS	"|c_interactive|c_sample|naverage|c_function\
			 |cn_order|low_reject|high_reject\
			 |abs_reject|em_reject|niterate|grow|"

# Continuum computation parameters
define	CNT_INTERACTIVE		1	# Do it interactively?
define	CNT_SAMPLE		2	# Sample string to use
define	CNT_NAVERAGE		3	# Npts to average in sample
define	CNT_FUNCTION		4	# Fitting function
define	CNT_CN_ORDER		5	# Order of function
define	LOW_REJECT		6	# Low rejection in sigma of fit
define	HIGH_REJECT		7	# High rejection in sigma of fit
define	ABS_REJECT		8	# Low rejection in sigma of fit
define	EM_REJECT		9	# High rejection in sigma of fit
define	CNT_NITERATE		10	# Number of rejection iterations
define	CNT_GROW		11	# Rejection growing radius

# Continuum removal method
define	CONT_TYPE		"|none|subtract|divide|zerodiv|outsub|"
define	NOCONT			1
define	SUBCONT			2
define	DIVCONT			3
define	ZEROCONT		4
define	OUTCONT			5

# Bad region method
define	BAD_TYPE		"|no|fill|zero|nzero|"
define  NOBAD			1	# Leave bad lines alone       
define  FILLBAD			2	# Interpolate linearly across bad lines
define  ZEROBAD			3	# Replace bad lines with zeroes
					# Ignore points during continuum fit
define  NZEROBAD		4	# Replace bad lines with zeroes
					# BEFORE continuum fit

# Feb  5 1997	Add continuum removal options

# Aug 18 1999	Add ZERODIV continuum removal option

# Jan 14 2000	Drop S_, T_ differentiation; add bad line methods
# Jan 18 2000	ZEROBAD now ignores bad points during continuum fit
